{***********************************************************}
{   This file is part of the DORB project.                  }
{                                                           }
{   See the file License, included in this distribution,    }
{   for details about the copyright.                        }
{                                                           }
{   Send comments and/or bug reports to: vic@inec.ru        }
{***********************************************************}
unit codeutil;

interface

uses
  classes,sysutils;

type

  TPrintStream = class(TMemoryStream)
  public
    procedure println(str: string = '');
    procedure print(str: string);
  end;

  function safe_name(name: string): string;

const
  CR: byte = 13;

implementation

//*********************************************************************
//  TPrintStream
//*********************************************************************
procedure TPrintStream.println;
begin
  if str <> '' then
    write(PChar(str)^,length(str));
  write(CR,1);
end;

procedure TPrintStream.print(str: string);
begin
  write(PChar(str)^,length(str));
end;

function safe_name(name: string): string;
begin
  result := name;
  name := lowercase(name);
  if (name = 'create') or (name = 'destroy') or (name = 'type') or (name = 'date') then
    result := '_'+result;
end;


end.
