// Generated by DORB idltopas compiler, 29.08.2000
unit calendar_impl;

interface

uses
  sysutils,windows,messages,orb_int,orb,req_int,code_int,imr,imr_int,env_int,except_int,types,
  stdstat,std_seq,poa,poa_int,value_int,classes,calendar_int, calendar;

type

  Tdate_impl = class(Tdate)
  protected
    function equal(const other: Idate): boolean; override;
    function compare(const other: Idate): smallint; override;
  public
    constructor Create(_day: _ushort; _month: _ushort; _year: _ushort);
  end;

  Tdate_factory = class(Tdate_init)
  protected
    function _create(dd: _ushort; mm: _ushort; yyyy: _ushort): Idate; override;
    function create_for_umarshal(): IValueBase; override;
  end;

  TCalendar_impl = class(TCalendar_serv)
  private
    FEntries: TStringList;
    FHandle: THandle;
  protected
    procedure insert(const when: Idate; const what: string); override;
    function find_date(const when: Idate; out what: string): boolean; override;
    function find_note(const what: string; out when: Idate): boolean; override;
  public
    constructor Create(hwnd: THandle);
    destructor Destroy(); override;
  end;

const
  CALENDAR_MESSAGE = WM_USER + 100;

implementation

//***********************************************************
// Tdate_impl
//***********************************************************
constructor Tdate_impl.Create(_day: _ushort; _month: _ushort; _year: _ushort);
begin
  inherited Create();
  Fdate_day := _day;
  Fdate_month := _month;
  Fdate_year := _year;
end;

function Tdate_impl.equal(const other: Idate): boolean;
begin
  result := compare(other) = 0;
end;

function Tdate_impl.compare(const other: Idate): smallint;
begin
  result := 0;
  if Fdate_year <> other.year then
    result := Fdate_year - other.year;
  if result <> 0 then exit;
  if Fdate_month <> other.month then
    result := Fdate_month - other.month;
  if result <> 0 then exit;
  if Fdate_day <> other.day then
    result := Fdate_day - other.day;
  if result <> 0 then exit;
  result := 0;
end;

//***********************************************************
// Tdate_factory
//***********************************************************
function Tdate_factory.create_for_umarshal(): IValueBase;
begin
  result := Tdate_impl.Create(0, 0, 0);
end;

function Tdate_factory._create(dd: _ushort; mm: _ushort; yyyy: _ushort): Idate;
begin
  result := Tdate_impl.Create(dd, mm, yyyy);
end;

//***********************************************************
// Calendar_impl
//***********************************************************
constructor TCalendar_impl.Create(hwnd: THandle);
begin
  inherited Create();
  FEntries := TStringList.Create;
  FHandle := hwnd;
end;

destructor TCalendar_impl.Destroy();
begin
  FEntries.Free;
end;

procedure TCalendar_impl.insert(const when: Idate; const what: string);
var
  d: longint;
  str: PChar;
  val: string;
begin
  d := (when.day shl 24) or (when.month shl 12) or (when.year and $FFF);
  FEntries.addObject(what,TObject(d));
  val := DateToStr(EncodeDate(when.Year,when.month,when.day))+': '+what;
  str := AllocMem(Length(val)+1);
  StrCopy(str,PChar(val));
  PostMessage(FHandle,CALENDAR_MESSAGE,Integer(PChar(str)),0);
end;

function TCalendar_impl.find_date(const when: Idate; out what: string): boolean;
var
  d: longint;
  i : integer;
begin
  d := (when.day shl 24) or (when.month shl 12) or (when.year and $FFF);
  i := FEntries.IndexOfObject(TObject(d));
  result := i >= 0;
  if result then
    what := FEntries[i];
end;

function TCalendar_impl.find_note(const what: string; out when: Idate): boolean;
var
  i : integer;
  d,m,y: word;
  dd : longint;
begin
  when := nil;
  result := false;
  for i := 0 to Pred(FEntries.count) do
    if pos(what,FEntries[i]) >= 0 then break;
  if i = FEntries.count then exit;
  result := true;
  if result then
    begin
      dd := Longint(FEntries.Objects[i]);
      d := dd shr 24;
      m := dd shr 12 and $3FF;
      y := dd and $FFF;
      when := Tdate_impl.Create(d,m,y);
    end;
end;

end.
