// **********************************************************************
//
// Copyright (c) 2001 MT Tools.
//
// All Rights Reserved
//
// MT_DORB is based in part on the product DORB,
// written by Shadrin Victor
//
// See Readme.txt for contact information
//
// **********************************************************************
unit imr_int;

interface

uses
  types,req_int,orb_int,env_int,classes,ir_int,code_int;

type

  IImplementationDef = interface;

  IObjectInfo = interface
  ['{AF662CB9-4D2E-11d4-9D27-204C4F4F5020}']
    function repoid(): string; overload;
    function tag(): string; overload;
    procedure repoid(val: string); overload;
    procedure tag(val: string); overload;
  end;

  IImplementationBase = interface(IORBObject)
  ['{AF662CBA-4D2E-11d4-9D27-204C4F4F5020}']
    //procedure create_ref(const id: string;const ImplBase: IUnknown;const repoid: string);
    procedure create_ref(const id: string;const idef: IInterfaceDef; const implDef : IImplementationDef;const repoid: string);
    function find_impl(const repid: string; const name: string): IImplementationDef;
    function impl_name(const name: string): string;
    function make_request(const req: IORBRequest;const obj: IORBObject; id: ORBMessageID;
       const oa: IObjectAdaptor; pr: IPrincipal):IServerRequestBase;
    procedure doinvoke(const req: IServerRequestBase; const env: IEnvironment);
  end;

  IStaticImplementation = interface(IImplementationBase)
  ['{AF662CBB-4D2E-11d4-9D27-204C4F4F5020}']
    procedure doinvoke(const req: IServerRequestBase; const env: IEnvironment);
    procedure invoke(const req: IStaticServerRequest; const env: IEnvironment);
  end;

  IStaticMethodDispatcher = interface(IStaticImplementation)
  ['{AF662CBC-4D2E-11d4-9D27-204C4F4F5020}']
    procedure register_dispatcher(const disp: IStaticInterfaceDispatcher);
  end;

  IImplementationDef = interface(IImplementationBase)
  ['{AF662CBD-4D2E-11d4-9D27-204C4F4F5020}']
    function name(): string;
  end;

  IImplRepository = interface(IImplementationBase)
  ['{AF662CBE-4D2E-11d4-9D27-204C4F4F5020}']
    function find_by_name(name: string): IInterfaceList;
    function _create(mode : TActivationMode;const objs: IInterfaceList;
      name: string; command: string): IImplementationDef;
  end;

implementation

end.
