
(* Yacc parser template (TP Yacc V3.0), V1.2 6-17-91 AG *)

(* global definitions: *)

{***********************************************************}
{   This file is part of the DORB project.                  }
{                                                           }
{   See the file License, included in this distribution,    }
{   for details about the copyright.                        }
{                                                           }
{   Send comments and/or bug reports to: vic@inec.ru        }
{***********************************************************}
unit idl;

interface

uses YaccLib, LexLib;

  function yyparse : Integer;

implementation

uses
  parser,sysutils;

const T_AMPERSAND = 257;
const T_ANY = 258;
const T_ASTERISK = 259;
const T_ATTRIBUTE = 260;
const T_BOOLEAN = 261;
const T_CASE = 262;
const T_CHAR = 263;
const T_CHARACTER_LITERAL = 264;
const T_CIRCUMFLEX = 265;
const T_COLON = 266;
const T_COMMA = 267;
const T_CONST = 268;
const T_CONTEXT = 269;
const T_DEFAULT = 270;
const T_DOUBLE = 271;
const T_ENUM = 272;
const T_EQUAL = 273;
const T_EXCEPTION = 274;
const T_FALSE = 275;
const T_FIXED = 276;
const T_FIXED_PT_LITERAL = 277;
const T_FLOAT = 278;
const T_FLOATING_PT_LITERAL = 279;
const T_GREATER_THAN_SIGN = 280;
const T_IDENTIFIER = 281;
const T_IN = 282;
const T_INOUT = 283;
const T_INTEGER_LITERAL = 284;
const T_INTERFACE = 285;
const T_LEFT_CURLY_BRACKET = 286;
const T_LEFT_PARANTHESIS = 287;
const T_LEFT_SQUARE_BRACKET = 288;
const T_LESS_THAN_SIGN = 289;
const T_LONG = 290;
const T_MINUS_SIGN = 291;
const T_MODULE = 292;
const T_OCTET = 293;
const T_ONEWAY = 294;
const T_OUT = 295;
const T_PERCENT_SIGN = 296;
const T_PLUS_SIGN = 297;
const T_RAISES = 298;
const T_READONLY = 299;
const T_RIGHT_CURLY_BRACKET = 300;
const T_RIGHT_PARANTHESIS = 301;
const T_RIGHT_SQUARE_BRACKET = 302;
const T_SCOPE = 303;
const T_SEMICOLON = 304;
const T_SEQUENCE = 305;
const T_SHIFTLEFT = 306;
const T_SHIFTRIGHT = 307;
const T_SHORT = 308;
const T_SOLIDUS = 309;
const T_STRING = 310;
const T_STRING_LITERAL = 311;
const T_PRAGMA = 312;
const T_INCLUDE = 313;
const T_STRUCT = 314;
const T_SWITCH = 315;
const T_TILDE = 316;
const T_TRUE = 317;
const T_OBJECT = 318;
const T_TYPEDEF = 319;
const T_UNION = 320;
const T_UNSIGNED = 321;
const T_VERTICAL_LINE = 322;
const T_VOID = 323;
const T_WCHAR = 324;
const T_WSTRING = 325;
const T_UNKNOWN = 326;
const T_ABSTRACT = 327;
const T_VALUETYPE = 328;
const T_TRUNCATABLE = 329;
const T_SUPPORTS = 330;
const T_CUSTOM = 331;
const T_PUBLIC = 332;
const T_PRIVATE = 333;
const T_FACTORY = 334;
const T_NATIVE = 335;
const T_VALUEBASE = 336;

type YYSType = record case Integer of
                 1 : ( yy_char : _char );
                 2 : ( yy_fixed : _fixed );
                 3 : ( yy_float : _float );
                 4 : ( yy_int : _int );
                 5 : ( yy_str : _str );
                 6 : ( yyident : ident );
                 7 : ( yynode : node );
               end(*YYSType*);

var yylval : YYSType;

function yylex : Integer; forward;

function yyparse : Integer;

var yystate, yysp, yyn : Integer;
    yys : array [1..yymaxdepth] of Integer;
    yyv : array [1..yymaxdepth] of YYSType;
    yyval : YYSType;

procedure yyaction ( yyruleno : Integer );
  (* local definitions: *)
begin
  (* actions: *)
  case yyruleno of
   1 : begin
         theParser.setRootNode(nil); 
       end;
   2 : begin
         theParser.setRootNode( yyv[yysp-0].yynode ); 
       end;
   3 : begin
         yyval.yynode := TNode.Create ( nt_definitions, yyv[yysp-0].yynode );
       end;
   4 : begin
         yyval.yynode := TNode.Create ( nt_definitions, yyv[yysp-1].yynode );
         		   yyval.yynode.setBranch( 2, yyv[yysp-0].yynode );
       end;
   5 : begin
         yyval.yynode := yyv[yysp-1].yynode;
       end;
   6 : begin
         yyval.yynode := yyv[yysp-1].yynode;
       end;
   7 : begin
         yyval.yynode := yyv[yysp-1].yynode;
       end;
   8 : begin
         yyval.yynode := yyv[yysp-1].yynode;
       end;
   9 : begin
         yyval.yynode := yyv[yysp-1].yynode;
       end;
  10 : begin
         yyval.yynode := yyv[yysp-1].yynode;
       end;
  11 : begin
         yyval.yynode := TNode.Create ( nt_pragma );
         		    yyval.yynode.setIdent( yyv[yysp-0].yy_str );
       end;
  12 : begin
         yyval.yynode := TNode.Create ( nt_include );
         		    yyval.yynode.setIdent( yyv[yysp-0].yy_str );
       end;
  13 : begin
         yyval.yynode := TNode.Create ( nt_module, yyv[yysp-1].yynode );
         		    yyval.yynode.setIdent( yyv[yysp-3].yyident );
       end;
  14 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
  15 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
  16 : begin
         yyval.yynode := TNode.Create ( nt_interface_dcl, yyv[yysp-3].yynode, yyv[yysp-1].yynode );
       end;
  17 : begin
         yyval.yynode := TNode.Create ( nt_forward_dcl );
         		    yyval.yynode.setIdent( yyv[yysp-0].yyident );
       end;
  18 : begin
         yyval.yynode := TNode.Create ( nt_abstract_forward_dcl );
         		    yyval.yynode.setIdent( yyv[yysp-0].yyident );
       end;
  19 : begin
         yyval.yynode := TNode.Create ( nt_interface_header );
         		    yyval.yynode.setIdent( yyv[yysp-0].yyident );
       end;
  20 : begin
         yyval.yynode := TNode.Create ( nt_interface_header );
         		    yyval.yynode.setIdent( yyv[yysp-1].yyident );
         		    yyval.yynode.setBranch( 1, yyv[yysp-0].yynode );
       end;
  21 : begin
         yyval.yynode := TNode.Create ( nt_abstract_interface_header );
         		    yyval.yynode.setIdent( yyv[yysp-0].yyident );
       end;
  22 : begin
         yyval.yynode := TNode.Create ( nt_abstract_interface_header );
         		    yyval.yynode.setIdent( yyv[yysp-1].yyident );
         		    yyval.yynode.setBranch( 1, yyv[yysp-0].yynode );
       end;
  23 : begin
         yyval.yynode := nil; 
       end;
  24 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
  25 : begin
         yyval.yynode := TNode.Create ( nt_exports, yyv[yysp-0].yynode );
       end;
  26 : begin
         yyval.yynode := TNode.Create ( nt_exports, yyv[yysp-1].yynode );
         		    yyval.yynode.setBranch( 2, yyv[yysp-0].yynode );
       end;
  27 : begin
         yyval.yynode := yyv[yysp-1].yynode;
       end;
  28 : begin
         yyval.yynode := yyv[yysp-1].yynode;
       end;
  29 : begin
         yyval.yynode := yyv[yysp-1].yynode;
       end;
  30 : begin
         yyval.yynode := yyv[yysp-1].yynode;
       end;
  31 : begin
         yyval.yynode := yyv[yysp-1].yynode;
       end;
  32 : begin
         yyval.yynode := TNode.Create ( nt_pragma );
         		    yyval.yynode.setIdent( yyv[yysp-0].yy_str );
       end;
  33 : begin
         yyval.yynode := TNode.Create ( nt_include );
         		    yyval.yynode.setIdent( yyv[yysp-0].yy_str );
       end;
  34 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
  35 : begin
         yyval := yyv[yysp-0];
       end;
  36 : begin
         yyval.yynode := TNode.Create ( nt_scoped_names, yyv[yysp-0].yynode );
       end;
  37 : begin
         yyval.yynode := TNode.Create ( nt_scoped_names, yyv[yysp-2].yynode );
         		    yyval.yynode.setBranch( 2, yyv[yysp-0].yynode );
       end;
  38 : begin
         yyval.yynode := TNode.Create ( nt_scoped_name );
         		    yyval.yynode.setIdent( yyv[yysp-0].yyident );
       end;
  39 : begin
         yyval.yynode := TNode.Create ( nt_scoped_name );
         		   yyval.yynode.setIdent('::'+yyv[yysp-0].yyident);
       end;
  40 : begin
         yyval.yynode := yyv[yysp-2].yynode;
         		   yyval.yynode.setIdent(yyval.yynode.getIdent()+'::'+yyv[yysp-0].yyident);
       end;
  41 : begin
         yyval := yyv[yysp-0];
       end;
  42 : begin
         yyval := yyv[yysp-0];
       end;
  43 : begin
         yyval := yyv[yysp-0];
       end;
  44 : begin
         yyval := yyv[yysp-0];
       end;
  45 : begin
         yyval.yynode := TNode.Create ( nt_value_forward_dcl );
         		    yyval.yynode.setIdent( yyv[yysp-0].yyident );
       end;
  46 : begin
         yyval.yynode := TNode.Create ( nt_abstract_value_forward_dcl );
         		    yyval.yynode.setIdent( yyv[yysp-0].yyident );
       end;
  47 : begin
         yyval.yynode := TNode.Create ( nt_value_box_dcl, yyv[yysp-0].yynode );
         		    yyval.yynode.setIdent( yyv[yysp-1].yyident ); 
       end;
  48 : begin
         yyval.yynode := TNode.Create ( nt_abstract_value_dcl );
         		    yyval.yynode.setBranch( 1, TNode.Create( nt_value_header ) );
         		    yyval.yynode.getBranch( 1 ).setIdent( yyv[yysp-3].yyident );
         		    yyval.yynode.setBranch( 2, yyv[yysp-1].yynode );
       end;
  49 : begin
         yyval.yynode := TNode.Create ( nt_abstract_value_dcl );
         		    yyval.yynode.setBranch( 1, TNode.Create( nt_value_header ) );
         		    yyval.yynode.getBranch( 1 ).setIdent( yyv[yysp-4].yyident );
         		    yyval.yynode.getBranch( 1 ).setBranch( 1, yyv[yysp-3].yynode );
         		    yyval.yynode.setBranch( 2, yyv[yysp-1].yynode );
       end;
  50 : begin
         yyval.yynode := nil;
       end;
  51 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
  52 : begin
         yyval.yynode := TNode.Create ( nt_value_dcl, yyv[yysp-3].yynode, yyv[yysp-1].yynode );
       end;
  53 : begin
         yyval.yynode := TNode.Create ( nt_value_dcl, yyv[yysp-2].yynode );
       end;
  54 : begin
         yyval.yynode := TNode.Create ( nt_value_elements, yyv[yysp-0].yynode );
       end;
  55 : begin
         yyval.yynode := TNode.Create ( nt_value_elements, yyv[yysp-1].yynode );
         		    yyval.yynode.setBranch( 2, yyv[yysp-0].yynode );
       end;
  56 : begin
         yyval.yynode := TNode.Create ( nt_value_header, yyv[yysp-0].yynode );
         		    yyval.yynode.setIdent( yyv[yysp-1].yyident );
       end;
  57 : begin
         yyval.yynode := TNode.Create ( nt_custom_value_header, yyv[yysp-0].yynode );
         		    yyval.yynode.setIdent( yyv[yysp-1].yyident );
       end;
  58 : begin
         yyval.yynode := TNode.Create ( nt_value_header );
         		    yyval.yynode.setIdent( yyv[yysp-0].yyident );
       end;
  59 : begin
         yyval.yynode := TNode.Create ( nt_custom_value_header );
         		    yyval.yynode.setIdent( yyv[yysp-0].yyident );
       end;
  60 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
  61 : begin
         yyval.yynode := yyv[yysp-2].yynode;
         		    yyval.yynode.setBranch( 4, yyv[yysp-0].yynode );
       end;
  62 : begin
         yyval.yynode := TNode.Create ( nt_value_inheritance_spec );
         		    yyval.yynode.setBranch( 4, yyv[yysp-0].yynode );
       end;
  63 : begin
         yyval.yynode := TNode.Create ( nt_value_inheritance_spec );
         		    yyval.yynode.setBranch( 1, yyv[yysp-0].yynode );
       end;
  64 : begin
         yyval.yynode := TNode.Create ( nt_value_inheritance_spec );
         		    yyval.yynode.setBranch( 1, yyv[yysp-2].yynode );
         		    yyval.yynode.setBranch( 3, yyv[yysp-0].yynode );
       end;
  65 : begin
         yyval.yynode := TNode.Create ( nt_value_inheritance_spec );
         		    yyval.yynode.setBranch( 2, yyv[yysp-0].yynode );
       end;
  66 : begin
         yyval.yynode := TNode.Create ( nt_value_inheritance_spec );
         		    yyval.yynode.setBranch( 2, yyv[yysp-2].yynode );
         		    yyval.yynode.setBranch( 3, yyv[yysp-0].yynode );
       end;
  67 : begin
         yyval := yyv[yysp-0];
       end;
  68 : begin
         yyval := yyv[yysp-0];
       end;
  69 : begin
         yyval := yyv[yysp-0];
       end;
  70 : begin
         yyval := yyv[yysp-0];
       end;
  71 : begin
         yyval := yyv[yysp-0];
       end;
  72 : begin
         yyval.yynode := TNode.Create ( nt_public_state_member, yyv[yysp-2].yynode, yyv[yysp-1].yynode );
       end;
  73 : begin
         yyval.yynode := TNode.Create ( nt_private_state_member, yyv[yysp-2].yynode, yyv[yysp-1].yynode );
       end;
  74 : begin
         yyval.yynode := TNode.Create ( nt_init_dcl, yyv[yysp-2].yynode );
         		    yyval.yynode.setIdent( yyv[yysp-4].yyident );
       end;
  75 : begin
         yyval.yynode := TNode.Create ( nt_init_param_decls, yyv[yysp-0].yynode );
       end;
  76 : begin
         yyval.yynode := TNode.Create ( nt_init_param_decls, yyv[yysp-2].yynode );
         		    yyval.yynode.setBranch( 2, yyv[yysp-0].yynode );
       end;
  77 : begin
         yyval.yynode := TNode.Create ( nt_init_param_decl, yyv[yysp-1].yynode, yyv[yysp-0].yynode );
       end;
  78 : begin
         yyval.yynode := nil;
       end;
  79 : begin
         yyval.yynode := TNode.Create ( nt_const_dcl, yyv[yysp-3].yynode, yyv[yysp-0].yynode );
         		    yyval.yynode.setIdent( yyv[yysp-2].yyident );
       end;
  80 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
  81 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
  82 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
  83 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
  84 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
  85 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
  86 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
  87 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
  88 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
  89 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
  90 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
  91 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
  92 : begin
         yyval.yynode := TNode.Create ( nt_vertical_line, yyv[yysp-2].yynode, yyv[yysp-0].yynode );
       end;
  93 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
  94 : begin
         yyval.yynode := TNode.Create ( nt_circumflex, yyv[yysp-2].yynode, yyv[yysp-0].yynode );
       end;
  95 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
  96 : begin
         yyval.yynode := TNode.Create ( nt_ampersand, yyv[yysp-2].yynode, yyv[yysp-0].yynode );
       end;
  97 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
  98 : begin
         yyval.yynode := TNode.Create ( nt_shiftright, yyv[yysp-2].yynode, yyv[yysp-0].yynode );
       end;
  99 : begin
         yyval.yynode := TNode.Create ( nt_shiftleft, yyv[yysp-2].yynode, yyv[yysp-0].yynode );
       end;
 100 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 101 : begin
         yyval.yynode := TNode.Create ( nt_plus_sign, yyv[yysp-2].yynode, yyv[yysp-0].yynode );
       end;
 102 : begin
         yyval.yynode := TNode.Create ( nt_minus_sign, yyv[yysp-2].yynode, yyv[yysp-0].yynode );
       end;
 103 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 104 : begin
         yyval.yynode := TNode.Create ( nt_asterik, yyv[yysp-2].yynode, yyv[yysp-0].yynode );
       end;
 105 : begin
         yyval.yynode := TNode.Create ( nt_solidus, yyv[yysp-2].yynode, yyv[yysp-0].yynode );
       end;
 106 : begin
         yyval.yynode := TNode.Create ( nt_percent_sign, yyv[yysp-2].yynode, yyv[yysp-0].yynode );
       end;
 107 : begin
         yyval.yynode := TNode.Create ( nt_minus_sign, yyv[yysp-0].yynode );
       end;
 108 : begin
         yyval.yynode := TNode.Create ( nt_plus_sign, yyv[yysp-0].yynode );
       end;
 109 : begin
         yyval.yynode := TNode.Create ( nt_tilde, yyv[yysp-0].yynode );
       end;
 110 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 111 : begin
         yyval.yynode := yyv[yysp-0].yynode;  
       end;
 112 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 113 : begin
         yyval.yynode := yyv[yysp-1].yynode;
       end;
 114 : begin
         yyval.yynode := TNode.Create ( nt_fixed_pt_literal );
         		    yyval.yynode.setFixedPtLiteral( yyv[yysp-0].yy_fixed );
       end;
 115 : begin
         yyval.yynode := TNode.Create ( nt_floating_pt_literal );
         		    yyval.yynode.setFloatingPtLiteral( yyv[yysp-0].yy_float );
       end;
 116 : begin
         yyval.yynode := TNode.Create ( nt_integer_literal );
         		    yyval.yynode.setIntegerLiteral( yyv[yysp-0].yy_int );
       end;
 117 : begin
         yyval.yynode := TNode.Create ( nt_string_literal );
         		    yyval.yynode.setStringLiteral( yyv[yysp-0].yy_str );
       end;
 118 : begin
         yyval.yynode := TNode.Create ( nt_character_literal );
         		    yyval.yynode.setCharacterLiteral( yyv[yysp-0].yy_char ); 
       end;
 119 : begin
         yyval.yynode := TNode.Create ( nt_boolean_literal );
         		    yyval.yynode.setBooleanLiteral( true );
       end;
 120 : begin
         yyval.yynode := TNode.Create ( nt_boolean_literal );
         		    yyval.yynode.setBooleanLiteral( false );
       end;
 121 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 122 : begin
         yyval.yynode := TNode.Create ( nt_typedef, yyv[yysp-1].yynode, yyv[yysp-0].yynode );
       end;
 123 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 124 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 125 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 126 : begin
         yyval.yynode := TNode.Create ( nt_native, yyv[yysp-0].yynode );
       end;
 127 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 128 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 129 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 130 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 131 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 132 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 133 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 134 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 135 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 136 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 137 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 138 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 139 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 140 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 141 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 142 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 143 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 144 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 145 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 146 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 147 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 148 : begin
         yyval.yynode := TNode.Create ( nt_declarators, yyv[yysp-0].yynode );
       end;
 149 : begin
         yyval.yynode := TNode.Create ( nt_declarators, yyv[yysp-2].yynode );
         		    yyval.yynode.setBranch( 2, yyv[yysp-0].yynode );
       end;
 150 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 151 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 152 : begin
         yyval.yynode := TNode.Create ( nt_simple_declarator );
         		    yyval.yynode.setIdent( yyv[yysp-0].yyident );
       end;
 153 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 154 : begin
         yyval.yynode := TNode.Create ( nt_float );
       end;
 155 : begin
         yyval.yynode := TNode.Create ( nt_double );
       end;
 156 : begin
         yyval.yynode := TNode.Create ( nt_long_double );
       end;
 157 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 158 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 159 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 160 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 161 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 162 : begin
         yyval.yynode := TNode.Create ( nt_short );
       end;
 163 : begin
         yyval.yynode := TNode.Create ( nt_long );
       end;
 164 : begin
         yyval.yynode := TNode.Create ( nt_longlong );
       end;
 165 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 166 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 167 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 168 : begin
         yyval.yynode := TNode.Create ( nt_unsigned_short );
       end;
 169 : begin
         yyval.yynode := TNode.Create ( nt_unsigned_long );
       end;
 170 : begin
         yyval.yynode := TNode.Create ( nt_unsigned_longlong );
       end;
 171 : begin
         yyval.yynode := TNode.Create ( nt_char );
       end;
 172 : begin
         yyval.yynode := TNode.Create ( nt_wide_char );
       end;
 173 : begin
         yyval.yynode := TNode.Create ( nt_boolean );
       end;
 174 : begin
         yyval.yynode := TNode.Create ( nt_octet );
       end;
 175 : begin
         yyval.yynode := TNode.Create ( nt_any );
       end;
 176 : begin
         yyval.yynode := TNode.Create ( nt_object );
       end;
 177 : begin
         yyval.yynode := TNode.Create ( nt_struct_type, yyv[yysp-1].yynode );
         		    yyval.yynode.setIdent( yyv[yysp-3].yyident ); 
       end;
 178 : begin
         yyval.yynode := TNode.Create ( nt_member_list, yyv[yysp-0].yynode ); 
       end;
 179 : begin
         yyval.yynode := TNode.Create ( nt_member_list, yyv[yysp-1].yynode );
         		    yyval.yynode.setBranch( 2, yyv[yysp-0].yynode ); 
       end;
 180 : begin
         yyval.yynode := TNode.Create ( nt_member, yyv[yysp-2].yynode, yyv[yysp-1].yynode );
       end;
 181 : begin
         yyval.yynode := TNode.Create ( nt_pragma );
         		    yyval.yynode.setIdent( yyv[yysp-0].yy_str );
       end;
 182 : begin
         yyval.yynode := TNode.Create ( nt_include );
         		    yyval.yynode.setIdent( yyv[yysp-0].yy_str );
       end;
 183 : begin
         yyval.yynode := TNode.Create ( nt_union_type, yyv[yysp-4].yynode, yyv[yysp-1].yynode );
         		    yyval.yynode.setIdent( yyv[yysp-7].yyident );
       end;
 184 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 185 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 186 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 187 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 188 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 189 : begin
         yyval.yynode := TNode.Create ( nt_switch_body, yyv[yysp-0].yynode );
       end;
 190 : begin
         yyval.yynode := TNode.Create ( nt_switch_body, yyv[yysp-1].yynode, yyv[yysp-0].yynode );
       end;
 191 : begin
         yyval.yynode := TNode.Create ( nt_case, yyv[yysp-1].yynode, yyv[yysp-0].yynode );
       end;
 192 : begin
         yyval.yynode := TNode.Create ( nt_case, yyv[yysp-2].yynode );
         		    yyval.yynode.setBranch( 3, yyv[yysp-1].yynode );
       end;
 193 : begin
         yyval.yynode := TNode.Create ( nt_case, yyv[yysp-3].yynode );
         		    yyval.yynode.setBranch( 3, yyv[yysp-1].yynode );
         		    yyval.yynode.setBranch( 4, TNode.Create  (nt_pragma));
         		    yyval.yynode.getBranch( 4).setIdent(yyv[yysp-2].yy_str);
       end;
 194 : begin
         yyval.yynode := yyv[yysp-1].yynode;
       end;
 195 : begin
         yyval.yynode := TNode.Create ( nt_default );
       end;
 196 : begin
         yyval.yynode := TNode.Create ( nt_element_spec, yyv[yysp-1].yynode, yyv[yysp-0].yynode );
       end;
 197 : begin
         yyval.yynode := TNode.Create ( nt_enum_type, yyv[yysp-1].yynode );
         		    yyval.yynode.setIdent( yyv[yysp-3].yyident );
       end;
 198 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 199 : begin
         yyval.yynode := TNode.Create ( nt_enumerators, yyv[yysp-2].yynode, yyv[yysp-0].yynode );
       end;
 200 : begin
         yyval.yynode := TNode.Create ( nt_enumerator );
         	           yyval.yynode.setIdent( yyv[yysp-0].yyident );
       end;
 201 : begin
         yyval.yynode := TNode.Create ( nt_sequence, yyv[yysp-3].yynode, yyv[yysp-1].yynode );
       end;
 202 : begin
         yyval.yynode := TNode.Create ( nt_sequence, yyv[yysp-1].yynode );
       end;
 203 : begin
         yyval.yynode := TNode.Create ( nt_string, yyv[yysp-1].yynode );
       end;
 204 : begin
         yyval.yynode := TNode.Create ( nt_string );
       end;
 205 : begin
         yyval.yynode := TNode.Create ( nt_wide_string, yyv[yysp-1].yynode );
       end;
 206 : begin
         yyval.yynode := TNode.Create ( nt_wide_string );
       end;
 207 : begin
         yyval.yynode := TNode.Create ( nt_array_declarator, yyv[yysp-0].yynode );
         		    yyval.yynode.setIdent( yyv[yysp-1].yyident );
       end;
 208 : begin
         yyval.yynode := TNode.Create ( nt_fixed_array_sizes, yyv[yysp-0].yynode );
       end;
 209 : begin
         yyval.yynode := TNode.Create ( nt_fixed_array_sizes, yyv[yysp-1].yynode );
         		   yyval.yynode.setBranch( 2, yyv[yysp-0].yynode );
       end;
 210 : begin
         yyval.yynode := yyv[yysp-1].yynode;
       end;
 211 : begin
         yyval.yynode := TNode.Create ( nt_attribute, yyv[yysp-1].yynode, yyv[yysp-0].yynode );
       end;
 212 : begin
         yyval.yynode := TNode.Create ( nt_readonly_attribute, yyv[yysp-1].yynode, yyv[yysp-0].yynode );
       end;
 213 : begin
         yyval.yynode := TNode.Create ( nt_simple_declarators, yyv[yysp-0].yynode );
       end;
 214 : begin
         yyval.yynode := TNode.Create ( nt_simple_declarators, yyv[yysp-2].yynode );
         		   yyval.yynode.setBranch( 2, yyv[yysp-0].yynode );
       end;
 215 : begin
         yyval.yynode := TNode.Create ( nt_except_dcl, yyv[yysp-1].yynode );
         		    yyval.yynode.setIdent( yyv[yysp-3].yyident );
       end;
 216 : begin
         yyval.yynode := nil;
       end;
 217 : begin
         yyval.yynode := TNode.Create ( nt_member_list, yyv[yysp-1].yynode );
         		   yyval.yynode.setBranch( 2, yyv[yysp-0].yynode );
       end;
 218 : begin
         yyval.yynode := TNode.Create ( nt_op_dcl, yyv[yysp-5].yynode, yyv[yysp-4].yynode, yyv[yysp-2].yynode, yyv[yysp-1].yynode, yyv[yysp-0].yynode );
         		   yyval.yynode.setIdent( yyv[yysp-3].yyident );
       end;
 219 : begin
         yyval.yynode := nil;
       end;
 220 : begin
         yyval.yynode := TNode.Create ( nt_oneway );
       end;
 221 : begin
         yyval.yynode := TNode.Create ( nt_op_type_spec, yyv[yysp-0].yynode );
       end;
 222 : begin
         yyval.yynode := TNode.Create ( nt_void );
       end;
 223 : begin
         yyval.yynode := yyv[yysp-1].yynode;
       end;
 224 : begin
         yyval.yynode := nil;
       end;
 225 : begin
         yyval.yynode := TNode.Create ( nt_param_dcls, yyv[yysp-0].yynode ); 
       end;
 226 : begin
         yyval.yynode := TNode.Create ( nt_param_dcls, yyv[yysp-2].yynode );
         		   yyval.yynode.setBranch( 2, yyv[yysp-0].yynode );
       end;
 227 : begin
         yyval.yynode := TNode.Create ( nt_param_dcl, yyv[yysp-2].yynode, yyv[yysp-1].yynode, yyv[yysp-0].yynode );
       end;
 228 : begin
         yyval.yynode := TNode.Create ( nt_in );
       end;
 229 : begin
         yyval.yynode := TNode.Create ( nt_out );
       end;
 230 : begin
         yyval.yynode := TNode.Create ( nt_inout );
       end;
 231 : begin
         yyval.yynode := nil;
       end;
 232 : begin
         yyval.yynode := TNode.Create ( nt_raises_expr, yyv[yysp-1].yynode );
       end;
 233 : begin
         yyval.yynode := nil;
       end;
 234 : begin
         yyval.yynode := yyv[yysp-1].yynode;
       end;
 235 : begin
         yyval.yynode := TNode.Create ( nt_string_literals );
         		   yyval.yynode.setIdent( yyv[yysp-0].yy_str );
       end;
 236 : begin
         yyval.yynode := TNode.Create ( nt_string_literals, yyv[yysp-0].yynode );
         		   yyval.yynode.setIdent( yyv[yysp-2].yy_str );
       end;
 237 : begin
         yyval.yy_str := yyv[yysp-0].yy_str;
       end;
 238 : begin
         yyval.yy_str := yyv[yysp-1].yy_str + ' ' + yyv[yysp-0].yy_str;
       end;
 239 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 240 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 241 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 242 : begin
         yyval.yynode := yyv[yysp-0].yynode;
       end;
 243 : begin
         yyval.yynode := TNode.Create ( nt_fixed_pt_type, yyv[yysp-3].yynode );
         		    yyval.yynode.setIntegerLiteral( yyv[yysp-1].yy_int );
       end;
 244 : begin
         yyval.yynode := TNode.Create ( nt_fixed_pt_type );
       end;
 245 : begin
         yyval.yynode := TNode.Create ( nt_valuebase );
       end;
  end;
end(*yyaction*);

(* parse table: *)

type YYARec = record
                sym, act : Integer;
              end;
     YYRRec = record
                len, sym : Integer;
              end;

const

yynacts   = 1247;
yyngotos  = 896;
yynstates = 391;
yynrules  = 245;

yya : array [1..yynacts] of YYARec = (
{ 0: }
  ( sym: 268; act: 21 ),
  ( sym: 272; act: 22 ),
  ( sym: 274; act: 23 ),
  ( sym: 285; act: 24 ),
  ( sym: 292; act: 25 ),
  ( sym: 312; act: 26 ),
  ( sym: 313; act: 27 ),
  ( sym: 314; act: 28 ),
  ( sym: 319; act: 29 ),
  ( sym: 320; act: 30 ),
  ( sym: 327; act: 31 ),
  ( sym: 328; act: 32 ),
  ( sym: 331; act: 33 ),
  ( sym: 335; act: 34 ),
  ( sym: 0; act: -1 ),
{ 1: }
  ( sym: 0; act: 0 ),
{ 2: }
  ( sym: 304; act: 35 ),
{ 3: }
{ 4: }
{ 5: }
{ 6: }
  ( sym: 304; act: 36 ),
{ 7: }
  ( sym: 304; act: 37 ),
{ 8: }
  ( sym: 286; act: 38 ),
{ 9: }
{ 10: }
{ 11: }
{ 12: }
  ( sym: 304; act: 39 ),
{ 13: }
{ 14: }
  ( sym: 286; act: 40 ),
{ 15: }
{ 16: }
{ 17: }
  ( sym: 304; act: 41 ),
{ 18: }
  ( sym: 304; act: 42 ),
{ 19: }
  ( sym: 268; act: 21 ),
  ( sym: 272; act: 22 ),
  ( sym: 274; act: 23 ),
  ( sym: 285; act: 24 ),
  ( sym: 292; act: 25 ),
  ( sym: 312; act: 26 ),
  ( sym: 313; act: 27 ),
  ( sym: 314; act: 28 ),
  ( sym: 319; act: 29 ),
  ( sym: 320; act: 30 ),
  ( sym: 327; act: 31 ),
  ( sym: 328; act: 32 ),
  ( sym: 331; act: 33 ),
  ( sym: 335; act: 34 ),
  ( sym: 0; act: -3 ),
  ( sym: 300; act: -3 ),
{ 20: }
{ 21: }
  ( sym: 261; act: 63 ),
  ( sym: 263; act: 64 ),
  ( sym: 271; act: 65 ),
  ( sym: 276; act: 66 ),
  ( sym: 278; act: 67 ),
  ( sym: 281; act: 68 ),
  ( sym: 290; act: 69 ),
  ( sym: 293; act: 70 ),
  ( sym: 303; act: 71 ),
  ( sym: 308; act: 72 ),
  ( sym: 310; act: 73 ),
  ( sym: 321; act: 74 ),
  ( sym: 324; act: 75 ),
  ( sym: 325; act: 76 ),
{ 22: }
  ( sym: 281; act: 77 ),
{ 23: }
  ( sym: 281; act: 78 ),
{ 24: }
  ( sym: 281; act: 79 ),
{ 25: }
  ( sym: 281; act: 80 ),
{ 26: }
{ 27: }
{ 28: }
  ( sym: 281; act: 81 ),
{ 29: }
  ( sym: 258; act: 104 ),
  ( sym: 261; act: 63 ),
  ( sym: 263; act: 64 ),
  ( sym: 271; act: 65 ),
  ( sym: 272; act: 22 ),
  ( sym: 276; act: 105 ),
  ( sym: 278; act: 67 ),
  ( sym: 281; act: 68 ),
  ( sym: 290; act: 69 ),
  ( sym: 293; act: 70 ),
  ( sym: 303; act: 71 ),
  ( sym: 305; act: 106 ),
  ( sym: 308; act: 72 ),
  ( sym: 310; act: 73 ),
  ( sym: 314; act: 28 ),
  ( sym: 318; act: 107 ),
  ( sym: 320; act: 30 ),
  ( sym: 321; act: 74 ),
  ( sym: 324; act: 75 ),
  ( sym: 325; act: 76 ),
  ( sym: 336; act: 108 ),
{ 30: }
  ( sym: 281; act: 109 ),
{ 31: }
  ( sym: 285; act: 110 ),
  ( sym: 328; act: 111 ),
{ 32: }
  ( sym: 281; act: 112 ),
{ 33: }
  ( sym: 328; act: 113 ),
{ 34: }
  ( sym: 281; act: 115 ),
{ 35: }
{ 36: }
{ 37: }
{ 38: }
  ( sym: 260; act: 127 ),
  ( sym: 268; act: 21 ),
  ( sym: 272; act: 22 ),
  ( sym: 274; act: 23 ),
  ( sym: 294; act: 128 ),
  ( sym: 299; act: 129 ),
  ( sym: 300; act: 130 ),
  ( sym: 312; act: 131 ),
  ( sym: 313; act: 132 ),
  ( sym: 314; act: 28 ),
  ( sym: 319; act: 29 ),
  ( sym: 320; act: 30 ),
  ( sym: 332; act: 133 ),
  ( sym: 333; act: 134 ),
  ( sym: 334; act: 135 ),
  ( sym: 335; act: 34 ),
  ( sym: 258; act: -219 ),
  ( sym: 261; act: -219 ),
  ( sym: 263; act: -219 ),
  ( sym: 271; act: -219 ),
  ( sym: 278; act: -219 ),
  ( sym: 281; act: -219 ),
  ( sym: 290; act: -219 ),
  ( sym: 293; act: -219 ),
  ( sym: 303; act: -219 ),
  ( sym: 308; act: -219 ),
  ( sym: 310; act: -219 ),
  ( sym: 318; act: -219 ),
  ( sym: 321; act: -219 ),
  ( sym: 323; act: -219 ),
  ( sym: 324; act: -219 ),
  ( sym: 325; act: -219 ),
  ( sym: 336; act: -219 ),
{ 39: }
{ 40: }
  ( sym: 260; act: 127 ),
  ( sym: 268; act: 21 ),
  ( sym: 272; act: 22 ),
  ( sym: 274; act: 23 ),
  ( sym: 294; act: 128 ),
  ( sym: 299; act: 129 ),
  ( sym: 312; act: 131 ),
  ( sym: 313; act: 132 ),
  ( sym: 314; act: 28 ),
  ( sym: 319; act: 29 ),
  ( sym: 320; act: 30 ),
  ( sym: 335; act: 34 ),
  ( sym: 300; act: -23 ),
  ( sym: 258; act: -219 ),
  ( sym: 261; act: -219 ),
  ( sym: 263; act: -219 ),
  ( sym: 271; act: -219 ),
  ( sym: 278; act: -219 ),
  ( sym: 281; act: -219 ),
  ( sym: 290; act: -219 ),
  ( sym: 293; act: -219 ),
  ( sym: 303; act: -219 ),
  ( sym: 308; act: -219 ),
  ( sym: 310; act: -219 ),
  ( sym: 318; act: -219 ),
  ( sym: 321; act: -219 ),
  ( sym: 323; act: -219 ),
  ( sym: 324; act: -219 ),
  ( sym: 325; act: -219 ),
  ( sym: 336; act: -219 ),
{ 41: }
{ 42: }
{ 43: }
{ 44: }
{ 45: }
{ 46: }
{ 47: }
{ 48: }
{ 49: }
{ 50: }
{ 51: }
{ 52: }
{ 53: }
{ 54: }
{ 55: }
{ 56: }
{ 57: }
{ 58: }
{ 59: }
{ 60: }
{ 61: }
  ( sym: 281; act: 139 ),
{ 62: }
  ( sym: 303; act: 140 ),
  ( sym: 281; act: -88 ),
{ 63: }
{ 64: }
{ 65: }
{ 66: }
{ 67: }
{ 68: }
{ 69: }
  ( sym: 271; act: 141 ),
  ( sym: 290; act: 142 ),
  ( sym: 267; act: -163 ),
  ( sym: 280; act: -163 ),
  ( sym: 281; act: -163 ),
  ( sym: 304; act: -163 ),
{ 70: }
{ 71: }
  ( sym: 281; act: 143 ),
{ 72: }
{ 73: }
  ( sym: 289; act: 144 ),
  ( sym: 267; act: -204 ),
  ( sym: 280; act: -204 ),
  ( sym: 281; act: -204 ),
  ( sym: 304; act: -204 ),
{ 74: }
  ( sym: 290; act: 145 ),
  ( sym: 308; act: 146 ),
{ 75: }
{ 76: }
  ( sym: 289; act: 147 ),
  ( sym: 267; act: -206 ),
  ( sym: 280; act: -206 ),
  ( sym: 281; act: -206 ),
  ( sym: 304; act: -206 ),
{ 77: }
  ( sym: 286; act: 148 ),
{ 78: }
  ( sym: 286; act: 149 ),
{ 79: }
  ( sym: 266; act: 151 ),
  ( sym: 304; act: -17 ),
  ( sym: 286; act: -19 ),
{ 80: }
  ( sym: 286; act: 152 ),
{ 81: }
  ( sym: 286; act: 153 ),
{ 82: }
{ 83: }
{ 84: }
{ 85: }
{ 86: }
{ 87: }
{ 88: }
{ 89: }
{ 90: }
{ 91: }
{ 92: }
{ 93: }
{ 94: }
{ 95: }
{ 96: }
{ 97: }
{ 98: }
{ 99: }
{ 100: }
{ 101: }
  ( sym: 281; act: 159 ),
{ 102: }
{ 103: }
  ( sym: 303; act: 140 ),
  ( sym: 267; act: -131 ),
  ( sym: 280; act: -131 ),
  ( sym: 281; act: -131 ),
  ( sym: 304; act: -131 ),
{ 104: }
{ 105: }
  ( sym: 289; act: 160 ),
{ 106: }
  ( sym: 289; act: 161 ),
{ 107: }
{ 108: }
{ 109: }
  ( sym: 315; act: 162 ),
{ 110: }
  ( sym: 281; act: 163 ),
{ 111: }
  ( sym: 281; act: 164 ),
{ 112: }
  ( sym: 258; act: 104 ),
  ( sym: 261; act: 63 ),
  ( sym: 263; act: 64 ),
  ( sym: 266; act: 167 ),
  ( sym: 271; act: 65 ),
  ( sym: 272; act: 22 ),
  ( sym: 276; act: 105 ),
  ( sym: 278; act: 67 ),
  ( sym: 281; act: 68 ),
  ( sym: 290; act: 69 ),
  ( sym: 293; act: 70 ),
  ( sym: 303; act: 71 ),
  ( sym: 305; act: 106 ),
  ( sym: 308; act: 72 ),
  ( sym: 310; act: 73 ),
  ( sym: 314; act: 28 ),
  ( sym: 318; act: 107 ),
  ( sym: 320; act: 30 ),
  ( sym: 321; act: 74 ),
  ( sym: 324; act: 75 ),
  ( sym: 325; act: 76 ),
  ( sym: 330; act: 168 ),
  ( sym: 336; act: 108 ),
  ( sym: 304; act: -45 ),
  ( sym: 286; act: -58 ),
{ 113: }
  ( sym: 281; act: 169 ),
{ 114: }
{ 115: }
{ 116: }
  ( sym: 304; act: 170 ),
{ 117: }
  ( sym: 258; act: 104 ),
  ( sym: 261; act: 63 ),
  ( sym: 263; act: 64 ),
  ( sym: 271; act: 65 ),
  ( sym: 278; act: 67 ),
  ( sym: 281; act: 68 ),
  ( sym: 290; act: 69 ),
  ( sym: 293; act: 70 ),
  ( sym: 303; act: 71 ),
  ( sym: 308; act: 72 ),
  ( sym: 310; act: 73 ),
  ( sym: 318; act: 107 ),
  ( sym: 321; act: 74 ),
  ( sym: 323; act: 177 ),
  ( sym: 324; act: 75 ),
  ( sym: 325; act: 76 ),
  ( sym: 336; act: 108 ),
{ 118: }
  ( sym: 304; act: 178 ),
{ 119: }
  ( sym: 304; act: 179 ),
{ 120: }
  ( sym: 304; act: 180 ),
{ 121: }
  ( sym: 304; act: 181 ),
{ 122: }
{ 123: }
{ 124: }
  ( sym: 260; act: 127 ),
  ( sym: 268; act: 21 ),
  ( sym: 272; act: 22 ),
  ( sym: 274; act: 23 ),
  ( sym: 294; act: 128 ),
  ( sym: 299; act: 129 ),
  ( sym: 312; act: 131 ),
  ( sym: 313; act: 132 ),
  ( sym: 314; act: 28 ),
  ( sym: 319; act: 29 ),
  ( sym: 320; act: 30 ),
  ( sym: 332; act: 133 ),
  ( sym: 333; act: 134 ),
  ( sym: 334; act: 135 ),
  ( sym: 335; act: 34 ),
  ( sym: 300; act: -54 ),
  ( sym: 258; act: -219 ),
  ( sym: 261; act: -219 ),
  ( sym: 263; act: -219 ),
  ( sym: 271; act: -219 ),
  ( sym: 278; act: -219 ),
  ( sym: 281; act: -219 ),
  ( sym: 290; act: -219 ),
  ( sym: 293; act: -219 ),
  ( sym: 303; act: -219 ),
  ( sym: 308; act: -219 ),
  ( sym: 310; act: -219 ),
  ( sym: 318; act: -219 ),
  ( sym: 321; act: -219 ),
  ( sym: 323; act: -219 ),
  ( sym: 324; act: -219 ),
  ( sym: 325; act: -219 ),
  ( sym: 336; act: -219 ),
{ 125: }
  ( sym: 300; act: 183 ),
{ 126: }
{ 127: }
  ( sym: 258; act: 104 ),
  ( sym: 261; act: 63 ),
  ( sym: 263; act: 64 ),
  ( sym: 271; act: 65 ),
  ( sym: 278; act: 67 ),
  ( sym: 281; act: 68 ),
  ( sym: 290; act: 69 ),
  ( sym: 293; act: 70 ),
  ( sym: 303; act: 71 ),
  ( sym: 308; act: 72 ),
  ( sym: 310; act: 73 ),
  ( sym: 318; act: 107 ),
  ( sym: 321; act: 74 ),
  ( sym: 324; act: 75 ),
  ( sym: 325; act: 76 ),
  ( sym: 336; act: 108 ),
{ 128: }
{ 129: }
  ( sym: 260; act: 185 ),
{ 130: }
{ 131: }
{ 132: }
{ 133: }
  ( sym: 258; act: 104 ),
  ( sym: 261; act: 63 ),
  ( sym: 263; act: 64 ),
  ( sym: 271; act: 65 ),
  ( sym: 272; act: 22 ),
  ( sym: 276; act: 105 ),
  ( sym: 278; act: 67 ),
  ( sym: 281; act: 68 ),
  ( sym: 290; act: 69 ),
  ( sym: 293; act: 70 ),
  ( sym: 303; act: 71 ),
  ( sym: 305; act: 106 ),
  ( sym: 308; act: 72 ),
  ( sym: 310; act: 73 ),
  ( sym: 314; act: 28 ),
  ( sym: 318; act: 107 ),
  ( sym: 320; act: 30 ),
  ( sym: 321; act: 74 ),
  ( sym: 324; act: 75 ),
  ( sym: 325; act: 76 ),
  ( sym: 336; act: 108 ),
{ 134: }
  ( sym: 258; act: 104 ),
  ( sym: 261; act: 63 ),
  ( sym: 263; act: 64 ),
  ( sym: 271; act: 65 ),
  ( sym: 272; act: 22 ),
  ( sym: 276; act: 105 ),
  ( sym: 278; act: 67 ),
  ( sym: 281; act: 68 ),
  ( sym: 290; act: 69 ),
  ( sym: 293; act: 70 ),
  ( sym: 303; act: 71 ),
  ( sym: 305; act: 106 ),
  ( sym: 308; act: 72 ),
  ( sym: 310; act: 73 ),
  ( sym: 314; act: 28 ),
  ( sym: 318; act: 107 ),
  ( sym: 320; act: 30 ),
  ( sym: 321; act: 74 ),
  ( sym: 324; act: 75 ),
  ( sym: 325; act: 76 ),
  ( sym: 336; act: 108 ),
{ 135: }
  ( sym: 281; act: 188 ),
{ 136: }
  ( sym: 260; act: 127 ),
  ( sym: 268; act: 21 ),
  ( sym: 272; act: 22 ),
  ( sym: 274; act: 23 ),
  ( sym: 294; act: 128 ),
  ( sym: 299; act: 129 ),
  ( sym: 312; act: 131 ),
  ( sym: 313; act: 132 ),
  ( sym: 314; act: 28 ),
  ( sym: 319; act: 29 ),
  ( sym: 320; act: 30 ),
  ( sym: 335; act: 34 ),
  ( sym: 300; act: -25 ),
  ( sym: 258; act: -219 ),
  ( sym: 261; act: -219 ),
  ( sym: 263; act: -219 ),
  ( sym: 271; act: -219 ),
  ( sym: 278; act: -219 ),
  ( sym: 281; act: -219 ),
  ( sym: 290; act: -219 ),
  ( sym: 293; act: -219 ),
  ( sym: 303; act: -219 ),
  ( sym: 308; act: -219 ),
  ( sym: 310; act: -219 ),
  ( sym: 318; act: -219 ),
  ( sym: 321; act: -219 ),
  ( sym: 323; act: -219 ),
  ( sym: 324; act: -219 ),
  ( sym: 325; act: -219 ),
  ( sym: 336; act: -219 ),
{ 137: }
{ 138: }
  ( sym: 300; act: 190 ),
{ 139: }
  ( sym: 273; act: 191 ),
{ 140: }
  ( sym: 281; act: 192 ),
{ 141: }
{ 142: }
{ 143: }
{ 144: }
  ( sym: 264; act: 206 ),
  ( sym: 275; act: 207 ),
  ( sym: 277; act: 208 ),
  ( sym: 279; act: 209 ),
  ( sym: 281; act: 68 ),
  ( sym: 284; act: 210 ),
  ( sym: 287; act: 211 ),
  ( sym: 291; act: 212 ),
  ( sym: 297; act: 213 ),
  ( sym: 303; act: 71 ),
  ( sym: 311; act: 214 ),
  ( sym: 316; act: 215 ),
  ( sym: 317; act: 216 ),
{ 145: }
  ( sym: 290; act: 217 ),
  ( sym: 267; act: -169 ),
  ( sym: 280; act: -169 ),
  ( sym: 281; act: -169 ),
  ( sym: 301; act: -169 ),
  ( sym: 304; act: -169 ),
{ 146: }
{ 147: }
  ( sym: 264; act: 206 ),
  ( sym: 275; act: 207 ),
  ( sym: 277; act: 208 ),
  ( sym: 279; act: 209 ),
  ( sym: 281; act: 68 ),
  ( sym: 284; act: 210 ),
  ( sym: 287; act: 211 ),
  ( sym: 291; act: 212 ),
  ( sym: 297; act: 213 ),
  ( sym: 303; act: 71 ),
  ( sym: 311; act: 214 ),
  ( sym: 316; act: 215 ),
  ( sym: 317; act: 216 ),
{ 148: }
  ( sym: 281; act: 221 ),
{ 149: }
  ( sym: 258; act: 104 ),
  ( sym: 261; act: 63 ),
  ( sym: 263; act: 64 ),
  ( sym: 271; act: 65 ),
  ( sym: 272; act: 22 ),
  ( sym: 276; act: 105 ),
  ( sym: 278; act: 67 ),
  ( sym: 281; act: 68 ),
  ( sym: 290; act: 69 ),
  ( sym: 293; act: 70 ),
  ( sym: 303; act: 71 ),
  ( sym: 305; act: 106 ),
  ( sym: 308; act: 72 ),
  ( sym: 310; act: 73 ),
  ( sym: 312; act: 225 ),
  ( sym: 313; act: 226 ),
  ( sym: 314; act: 28 ),
  ( sym: 318; act: 107 ),
  ( sym: 320; act: 30 ),
  ( sym: 321; act: 74 ),
  ( sym: 324; act: 75 ),
  ( sym: 325; act: 76 ),
  ( sym: 336; act: 108 ),
  ( sym: 300; act: -216 ),
{ 150: }
{ 151: }
  ( sym: 281; act: 68 ),
  ( sym: 303; act: 71 ),
{ 152: }
  ( sym: 268; act: 21 ),
  ( sym: 272; act: 22 ),
  ( sym: 274; act: 23 ),
  ( sym: 285; act: 24 ),
  ( sym: 292; act: 25 ),
  ( sym: 312; act: 26 ),
  ( sym: 313; act: 27 ),
  ( sym: 314; act: 28 ),
  ( sym: 319; act: 29 ),
  ( sym: 320; act: 30 ),
  ( sym: 327; act: 31 ),
  ( sym: 328; act: 32 ),
  ( sym: 331; act: 33 ),
  ( sym: 335; act: 34 ),
{ 153: }
  ( sym: 258; act: 104 ),
  ( sym: 261; act: 63 ),
  ( sym: 263; act: 64 ),
  ( sym: 271; act: 65 ),
  ( sym: 272; act: 22 ),
  ( sym: 276; act: 105 ),
  ( sym: 278; act: 67 ),
  ( sym: 281; act: 68 ),
  ( sym: 290; act: 69 ),
  ( sym: 293; act: 70 ),
  ( sym: 303; act: 71 ),
  ( sym: 305; act: 106 ),
  ( sym: 308; act: 72 ),
  ( sym: 310; act: 73 ),
  ( sym: 312; act: 225 ),
  ( sym: 313; act: 226 ),
  ( sym: 314; act: 28 ),
  ( sym: 318; act: 107 ),
  ( sym: 320; act: 30 ),
  ( sym: 321; act: 74 ),
  ( sym: 324; act: 75 ),
  ( sym: 325; act: 76 ),
  ( sym: 336; act: 108 ),
{ 154: }
{ 155: }
{ 156: }
{ 157: }
  ( sym: 267; act: 233 ),
  ( sym: 304; act: -148 ),
{ 158: }
{ 159: }
  ( sym: 288; act: 236 ),
  ( sym: 267; act: -152 ),
  ( sym: 304; act: -152 ),
{ 160: }
  ( sym: 264; act: 206 ),
  ( sym: 275; act: 207 ),
  ( sym: 277; act: 208 ),
  ( sym: 279; act: 209 ),
  ( sym: 281; act: 68 ),
  ( sym: 284; act: 210 ),
  ( sym: 287; act: 211 ),
  ( sym: 291; act: 212 ),
  ( sym: 297; act: 213 ),
  ( sym: 303; act: 71 ),
  ( sym: 311; act: 214 ),
  ( sym: 316; act: 215 ),
  ( sym: 317; act: 216 ),
{ 161: }
  ( sym: 258; act: 104 ),
  ( sym: 261; act: 63 ),
  ( sym: 263; act: 64 ),
  ( sym: 271; act: 65 ),
  ( sym: 276; act: 105 ),
  ( sym: 278; act: 67 ),
  ( sym: 281; act: 68 ),
  ( sym: 290; act: 69 ),
  ( sym: 293; act: 70 ),
  ( sym: 303; act: 71 ),
  ( sym: 305; act: 106 ),
  ( sym: 308; act: 72 ),
  ( sym: 310; act: 73 ),
  ( sym: 318; act: 107 ),
  ( sym: 321; act: 74 ),
  ( sym: 324; act: 75 ),
  ( sym: 325; act: 76 ),
  ( sym: 336; act: 108 ),
{ 162: }
  ( sym: 287; act: 239 ),
{ 163: }
  ( sym: 266; act: 151 ),
  ( sym: 304; act: -18 ),
  ( sym: 286; act: -21 ),
{ 164: }
  ( sym: 266; act: 167 ),
  ( sym: 286; act: 242 ),
  ( sym: 330; act: 168 ),
  ( sym: 304; act: -46 ),
{ 165: }
{ 166: }
{ 167: }
  ( sym: 281; act: 68 ),
  ( sym: 303; act: 71 ),
  ( sym: 329; act: 246 ),
{ 168: }
  ( sym: 281; act: 68 ),
  ( sym: 303; act: 71 ),
{ 169: }
  ( sym: 266; act: 167 ),
  ( sym: 330; act: 168 ),
  ( sym: 286; act: -59 ),
{ 170: }
{ 171: }
{ 172: }
  ( sym: 281; act: 249 ),
{ 173: }
{ 174: }
{ 175: }
{ 176: }
  ( sym: 303; act: 140 ),
  ( sym: 281; act: -242 ),
{ 177: }
{ 178: }
{ 179: }
{ 180: }
{ 181: }
{ 182: }
{ 183: }
{ 184: }
  ( sym: 281; act: 115 ),
{ 185: }
  ( sym: 258; act: 104 ),
  ( sym: 261; act: 63 ),
  ( sym: 263; act: 64 ),
  ( sym: 271; act: 65 ),
  ( sym: 278; act: 67 ),
  ( sym: 281; act: 68 ),
  ( sym: 290; act: 69 ),
  ( sym: 293; act: 70 ),
  ( sym: 303; act: 71 ),
  ( sym: 308; act: 72 ),
  ( sym: 310; act: 73 ),
  ( sym: 318; act: 107 ),
  ( sym: 321; act: 74 ),
  ( sym: 324; act: 75 ),
  ( sym: 325; act: 76 ),
  ( sym: 336; act: 108 ),
{ 186: }
  ( sym: 281; act: 159 ),
{ 187: }
  ( sym: 281; act: 159 ),
{ 188: }
  ( sym: 287; act: 255 ),
{ 189: }
{ 190: }
{ 191: }
  ( sym: 264; act: 206 ),
  ( sym: 275; act: 207 ),
  ( sym: 277; act: 208 ),
  ( sym: 279; act: 209 ),
  ( sym: 281; act: 68 ),
  ( sym: 284; act: 210 ),
  ( sym: 287; act: 211 ),
  ( sym: 291; act: 212 ),
  ( sym: 297; act: 213 ),
  ( sym: 303; act: 71 ),
  ( sym: 311; act: 214 ),
  ( sym: 316; act: 215 ),
  ( sym: 317; act: 216 ),
{ 192: }
{ 193: }
{ 194: }
{ 195: }
  ( sym: 280; act: 257 ),
{ 196: }
{ 197: }
{ 198: }
  ( sym: 259; act: 258 ),
  ( sym: 296; act: 259 ),
  ( sym: 309; act: 260 ),
  ( sym: 257; act: -100 ),
  ( sym: 265; act: -100 ),
  ( sym: 266; act: -100 ),
  ( sym: 267; act: -100 ),
  ( sym: 280; act: -100 ),
  ( sym: 291; act: -100 ),
  ( sym: 297; act: -100 ),
  ( sym: 301; act: -100 ),
  ( sym: 302; act: -100 ),
  ( sym: 304; act: -100 ),
  ( sym: 306; act: -100 ),
  ( sym: 307; act: -100 ),
  ( sym: 322; act: -100 ),
{ 199: }
  ( sym: 291; act: 261 ),
  ( sym: 297; act: 262 ),
  ( sym: 257; act: -97 ),
  ( sym: 265; act: -97 ),
  ( sym: 266; act: -97 ),
  ( sym: 267; act: -97 ),
  ( sym: 280; act: -97 ),
  ( sym: 301; act: -97 ),
  ( sym: 302; act: -97 ),
  ( sym: 304; act: -97 ),
  ( sym: 306; act: -97 ),
  ( sym: 307; act: -97 ),
  ( sym: 322; act: -97 ),
{ 200: }
  ( sym: 306; act: 263 ),
  ( sym: 307; act: 264 ),
  ( sym: 257; act: -95 ),
  ( sym: 265; act: -95 ),
  ( sym: 266; act: -95 ),
  ( sym: 267; act: -95 ),
  ( sym: 280; act: -95 ),
  ( sym: 301; act: -95 ),
  ( sym: 302; act: -95 ),
  ( sym: 304; act: -95 ),
  ( sym: 322; act: -95 ),
{ 201: }
  ( sym: 257; act: 265 ),
  ( sym: 265; act: -93 ),
  ( sym: 266; act: -93 ),
  ( sym: 267; act: -93 ),
  ( sym: 280; act: -93 ),
  ( sym: 301; act: -93 ),
  ( sym: 302; act: -93 ),
  ( sym: 304; act: -93 ),
  ( sym: 322; act: -93 ),
{ 202: }
  ( sym: 265; act: 266 ),
  ( sym: 266; act: -91 ),
  ( sym: 267; act: -91 ),
  ( sym: 280; act: -91 ),
  ( sym: 301; act: -91 ),
  ( sym: 302; act: -91 ),
  ( sym: 304; act: -91 ),
  ( sym: 322; act: -91 ),
{ 203: }
  ( sym: 322; act: 267 ),
  ( sym: 266; act: -90 ),
  ( sym: 267; act: -90 ),
  ( sym: 280; act: -90 ),
  ( sym: 301; act: -90 ),
  ( sym: 302; act: -90 ),
  ( sym: 304; act: -90 ),
{ 204: }
{ 205: }
  ( sym: 303; act: 140 ),
  ( sym: 257; act: -111 ),
  ( sym: 259; act: -111 ),
  ( sym: 265; act: -111 ),
  ( sym: 266; act: -111 ),
  ( sym: 267; act: -111 ),
  ( sym: 280; act: -111 ),
  ( sym: 291; act: -111 ),
  ( sym: 296; act: -111 ),
  ( sym: 297; act: -111 ),
  ( sym: 301; act: -111 ),
  ( sym: 302; act: -111 ),
  ( sym: 304; act: -111 ),
  ( sym: 306; act: -111 ),
  ( sym: 307; act: -111 ),
  ( sym: 309; act: -111 ),
  ( sym: 322; act: -111 ),
{ 206: }
{ 207: }
{ 208: }
{ 209: }
{ 210: }
{ 211: }
  ( sym: 264; act: 206 ),
  ( sym: 275; act: 207 ),
  ( sym: 277; act: 208 ),
  ( sym: 279; act: 209 ),
  ( sym: 281; act: 68 ),
  ( sym: 284; act: 210 ),
  ( sym: 287; act: 211 ),
  ( sym: 291; act: 212 ),
  ( sym: 297; act: 213 ),
  ( sym: 303; act: 71 ),
  ( sym: 311; act: 214 ),
  ( sym: 316; act: 215 ),
  ( sym: 317; act: 216 ),
{ 212: }
  ( sym: 264; act: 206 ),
  ( sym: 275; act: 207 ),
  ( sym: 277; act: 208 ),
  ( sym: 279; act: 209 ),
  ( sym: 281; act: 68 ),
  ( sym: 284; act: 210 ),
  ( sym: 287; act: 211 ),
  ( sym: 303; act: 71 ),
  ( sym: 311; act: 214 ),
  ( sym: 317; act: 216 ),
{ 213: }
  ( sym: 264; act: 206 ),
  ( sym: 275; act: 207 ),
  ( sym: 277; act: 208 ),
  ( sym: 279; act: 209 ),
  ( sym: 281; act: 68 ),
  ( sym: 284; act: 210 ),
  ( sym: 287; act: 211 ),
  ( sym: 303; act: 71 ),
  ( sym: 311; act: 214 ),
  ( sym: 317; act: 216 ),
{ 214: }
  ( sym: 311; act: 214 ),
  ( sym: 257; act: -237 ),
  ( sym: 259; act: -237 ),
  ( sym: 265; act: -237 ),
  ( sym: 266; act: -237 ),
  ( sym: 267; act: -237 ),
  ( sym: 280; act: -237 ),
  ( sym: 291; act: -237 ),
  ( sym: 296; act: -237 ),
  ( sym: 297; act: -237 ),
  ( sym: 301; act: -237 ),
  ( sym: 302; act: -237 ),
  ( sym: 304; act: -237 ),
  ( sym: 306; act: -237 ),
  ( sym: 307; act: -237 ),
  ( sym: 309; act: -237 ),
  ( sym: 322; act: -237 ),
{ 215: }
  ( sym: 264; act: 206 ),
  ( sym: 275; act: 207 ),
  ( sym: 277; act: 208 ),
  ( sym: 279; act: 209 ),
  ( sym: 281; act: 68 ),
  ( sym: 284; act: 210 ),
  ( sym: 287; act: 211 ),
  ( sym: 303; act: 71 ),
  ( sym: 311; act: 214 ),
  ( sym: 317; act: 216 ),
{ 216: }
{ 217: }
{ 218: }
  ( sym: 280; act: 273 ),
{ 219: }
  ( sym: 267; act: 274 ),
  ( sym: 300; act: -198 ),
{ 220: }
  ( sym: 300; act: 275 ),
{ 221: }
{ 222: }
  ( sym: 300; act: 276 ),
{ 223: }
  ( sym: 258; act: 104 ),
  ( sym: 261; act: 63 ),
  ( sym: 263; act: 64 ),
  ( sym: 271; act: 65 ),
  ( sym: 272; act: 22 ),
  ( sym: 276; act: 105 ),
  ( sym: 278; act: 67 ),
  ( sym: 281; act: 68 ),
  ( sym: 290; act: 69 ),
  ( sym: 293; act: 70 ),
  ( sym: 303; act: 71 ),
  ( sym: 305; act: 106 ),
  ( sym: 308; act: 72 ),
  ( sym: 310; act: 73 ),
  ( sym: 312; act: 225 ),
  ( sym: 313; act: 226 ),
  ( sym: 314; act: 28 ),
  ( sym: 318; act: 107 ),
  ( sym: 320; act: 30 ),
  ( sym: 321; act: 74 ),
  ( sym: 324; act: 75 ),
  ( sym: 325; act: 76 ),
  ( sym: 336; act: 108 ),
  ( sym: 300; act: -216 ),
{ 224: }
  ( sym: 281; act: 159 ),
{ 225: }
{ 226: }
{ 227: }
  ( sym: 267; act: 279 ),
  ( sym: 303; act: 140 ),
  ( sym: 286; act: -36 ),
  ( sym: 301; act: -36 ),
  ( sym: 330; act: -36 ),
{ 228: }
{ 229: }
{ 230: }
  ( sym: 300; act: 280 ),
{ 231: }
  ( sym: 258; act: 104 ),
  ( sym: 261; act: 63 ),
  ( sym: 263; act: 64 ),
  ( sym: 271; act: 65 ),
  ( sym: 272; act: 22 ),
  ( sym: 276; act: 105 ),
  ( sym: 278; act: 67 ),
  ( sym: 281; act: 68 ),
  ( sym: 290; act: 69 ),
  ( sym: 293; act: 70 ),
  ( sym: 303; act: 71 ),
  ( sym: 305; act: 106 ),
  ( sym: 308; act: 72 ),
  ( sym: 310; act: 73 ),
  ( sym: 312; act: 225 ),
  ( sym: 313; act: 226 ),
  ( sym: 314; act: 28 ),
  ( sym: 318; act: 107 ),
  ( sym: 320; act: 30 ),
  ( sym: 321; act: 74 ),
  ( sym: 324; act: 75 ),
  ( sym: 325; act: 76 ),
  ( sym: 336; act: 108 ),
  ( sym: 300; act: -178 ),
{ 232: }
  ( sym: 300; act: 282 ),
{ 233: }
  ( sym: 281; act: 159 ),
{ 234: }
  ( sym: 288; act: 236 ),
  ( sym: 267; act: -208 ),
  ( sym: 304; act: -208 ),
{ 235: }
{ 236: }
  ( sym: 264; act: 206 ),
  ( sym: 275; act: 207 ),
  ( sym: 277; act: 208 ),
  ( sym: 279; act: 209 ),
  ( sym: 281; act: 68 ),
  ( sym: 284; act: 210 ),
  ( sym: 287; act: 211 ),
  ( sym: 291; act: 212 ),
  ( sym: 297; act: 213 ),
  ( sym: 303; act: 71 ),
  ( sym: 311; act: 214 ),
  ( sym: 316; act: 215 ),
  ( sym: 317; act: 216 ),
{ 237: }
  ( sym: 267; act: 286 ),
{ 238: }
  ( sym: 267; act: 287 ),
  ( sym: 280; act: 288 ),
{ 239: }
  ( sym: 261; act: 63 ),
  ( sym: 263; act: 64 ),
  ( sym: 272; act: 22 ),
  ( sym: 281; act: 68 ),
  ( sym: 290; act: 295 ),
  ( sym: 303; act: 71 ),
  ( sym: 308; act: 72 ),
  ( sym: 321; act: 74 ),
{ 240: }
{ 241: }
  ( sym: 286; act: 296 ),
{ 242: }
  ( sym: 260; act: 127 ),
  ( sym: 268; act: 21 ),
  ( sym: 272; act: 22 ),
  ( sym: 274; act: 23 ),
  ( sym: 294; act: 128 ),
  ( sym: 299; act: 129 ),
  ( sym: 312; act: 131 ),
  ( sym: 313; act: 132 ),
  ( sym: 314; act: 28 ),
  ( sym: 319; act: 29 ),
  ( sym: 320; act: 30 ),
  ( sym: 335; act: 34 ),
  ( sym: 300; act: -50 ),
  ( sym: 258; act: -219 ),
  ( sym: 261; act: -219 ),
  ( sym: 263; act: -219 ),
  ( sym: 271; act: -219 ),
  ( sym: 278; act: -219 ),
  ( sym: 281; act: -219 ),
  ( sym: 290; act: -219 ),
  ( sym: 293; act: -219 ),
  ( sym: 303; act: -219 ),
  ( sym: 308; act: -219 ),
  ( sym: 310; act: -219 ),
  ( sym: 318; act: -219 ),
  ( sym: 321; act: -219 ),
  ( sym: 323; act: -219 ),
  ( sym: 324; act: -219 ),
  ( sym: 325; act: -219 ),
  ( sym: 336; act: -219 ),
{ 243: }
  ( sym: 267; act: 299 ),
  ( sym: 286; act: -63 ),
  ( sym: 330; act: -63 ),
{ 244: }
  ( sym: 330; act: 300 ),
  ( sym: 286; act: -60 ),
{ 245: }
  ( sym: 303; act: 140 ),
  ( sym: 267; act: -68 ),
  ( sym: 286; act: -68 ),
  ( sym: 330; act: -68 ),
{ 246: }
  ( sym: 281; act: 68 ),
  ( sym: 303; act: 71 ),
{ 247: }
{ 248: }
{ 249: }
  ( sym: 287; act: 303 ),
{ 250: }
{ 251: }
  ( sym: 267; act: 304 ),
  ( sym: 304; act: -213 ),
{ 252: }
  ( sym: 281; act: 115 ),
{ 253: }
  ( sym: 304; act: 306 ),
{ 254: }
  ( sym: 304; act: 307 ),
{ 255: }
  ( sym: 282; act: 311 ),
{ 256: }
{ 257: }
{ 258: }
  ( sym: 264; act: 206 ),
  ( sym: 275; act: 207 ),
  ( sym: 277; act: 208 ),
  ( sym: 279; act: 209 ),
  ( sym: 281; act: 68 ),
  ( sym: 284; act: 210 ),
  ( sym: 287; act: 211 ),
  ( sym: 291; act: 212 ),
  ( sym: 297; act: 213 ),
  ( sym: 303; act: 71 ),
  ( sym: 311; act: 214 ),
  ( sym: 316; act: 215 ),
  ( sym: 317; act: 216 ),
{ 259: }
  ( sym: 264; act: 206 ),
  ( sym: 275; act: 207 ),
  ( sym: 277; act: 208 ),
  ( sym: 279; act: 209 ),
  ( sym: 281; act: 68 ),
  ( sym: 284; act: 210 ),
  ( sym: 287; act: 211 ),
  ( sym: 291; act: 212 ),
  ( sym: 297; act: 213 ),
  ( sym: 303; act: 71 ),
  ( sym: 311; act: 214 ),
  ( sym: 316; act: 215 ),
  ( sym: 317; act: 216 ),
{ 260: }
  ( sym: 264; act: 206 ),
  ( sym: 275; act: 207 ),
  ( sym: 277; act: 208 ),
  ( sym: 279; act: 209 ),
  ( sym: 281; act: 68 ),
  ( sym: 284; act: 210 ),
  ( sym: 287; act: 211 ),
  ( sym: 291; act: 212 ),
  ( sym: 297; act: 213 ),
  ( sym: 303; act: 71 ),
  ( sym: 311; act: 214 ),
  ( sym: 316; act: 215 ),
  ( sym: 317; act: 216 ),
{ 261: }
  ( sym: 264; act: 206 ),
  ( sym: 275; act: 207 ),
  ( sym: 277; act: 208 ),
  ( sym: 279; act: 209 ),
  ( sym: 281; act: 68 ),
  ( sym: 284; act: 210 ),
  ( sym: 287; act: 211 ),
  ( sym: 291; act: 212 ),
  ( sym: 297; act: 213 ),
  ( sym: 303; act: 71 ),
  ( sym: 311; act: 214 ),
  ( sym: 316; act: 215 ),
  ( sym: 317; act: 216 ),
{ 262: }
  ( sym: 264; act: 206 ),
  ( sym: 275; act: 207 ),
  ( sym: 277; act: 208 ),
  ( sym: 279; act: 209 ),
  ( sym: 281; act: 68 ),
  ( sym: 284; act: 210 ),
  ( sym: 287; act: 211 ),
  ( sym: 291; act: 212 ),
  ( sym: 297; act: 213 ),
  ( sym: 303; act: 71 ),
  ( sym: 311; act: 214 ),
  ( sym: 316; act: 215 ),
  ( sym: 317; act: 216 ),
{ 263: }
  ( sym: 264; act: 206 ),
  ( sym: 275; act: 207 ),
  ( sym: 277; act: 208 ),
  ( sym: 279; act: 209 ),
  ( sym: 281; act: 68 ),
  ( sym: 284; act: 210 ),
  ( sym: 287; act: 211 ),
  ( sym: 291; act: 212 ),
  ( sym: 297; act: 213 ),
  ( sym: 303; act: 71 ),
  ( sym: 311; act: 214 ),
  ( sym: 316; act: 215 ),
  ( sym: 317; act: 216 ),
{ 264: }
  ( sym: 264; act: 206 ),
  ( sym: 275; act: 207 ),
  ( sym: 277; act: 208 ),
  ( sym: 279; act: 209 ),
  ( sym: 281; act: 68 ),
  ( sym: 284; act: 210 ),
  ( sym: 287; act: 211 ),
  ( sym: 291; act: 212 ),
  ( sym: 297; act: 213 ),
  ( sym: 303; act: 71 ),
  ( sym: 311; act: 214 ),
  ( sym: 316; act: 215 ),
  ( sym: 317; act: 216 ),
{ 265: }
  ( sym: 264; act: 206 ),
  ( sym: 275; act: 207 ),
  ( sym: 277; act: 208 ),
  ( sym: 279; act: 209 ),
  ( sym: 281; act: 68 ),
  ( sym: 284; act: 210 ),
  ( sym: 287; act: 211 ),
  ( sym: 291; act: 212 ),
  ( sym: 297; act: 213 ),
  ( sym: 303; act: 71 ),
  ( sym: 311; act: 214 ),
  ( sym: 316; act: 215 ),
  ( sym: 317; act: 216 ),
{ 266: }
  ( sym: 264; act: 206 ),
  ( sym: 275; act: 207 ),
  ( sym: 277; act: 208 ),
  ( sym: 279; act: 209 ),
  ( sym: 281; act: 68 ),
  ( sym: 284; act: 210 ),
  ( sym: 287; act: 211 ),
  ( sym: 291; act: 212 ),
  ( sym: 297; act: 213 ),
  ( sym: 303; act: 71 ),
  ( sym: 311; act: 214 ),
  ( sym: 316; act: 215 ),
  ( sym: 317; act: 216 ),
{ 267: }
  ( sym: 264; act: 206 ),
  ( sym: 275; act: 207 ),
  ( sym: 277; act: 208 ),
  ( sym: 279; act: 209 ),
  ( sym: 281; act: 68 ),
  ( sym: 284; act: 210 ),
  ( sym: 287; act: 211 ),
  ( sym: 291; act: 212 ),
  ( sym: 297; act: 213 ),
  ( sym: 303; act: 71 ),
  ( sym: 311; act: 214 ),
  ( sym: 316; act: 215 ),
  ( sym: 317; act: 216 ),
{ 268: }
  ( sym: 301; act: 322 ),
{ 269: }
{ 270: }
{ 271: }
{ 272: }
{ 273: }
{ 274: }
  ( sym: 281; act: 221 ),
{ 275: }
{ 276: }
{ 277: }
{ 278: }
  ( sym: 304; act: 324 ),
{ 279: }
  ( sym: 281; act: 68 ),
  ( sym: 303; act: 71 ),
{ 280: }
{ 281: }
{ 282: }
{ 283: }
{ 284: }
{ 285: }
  ( sym: 302; act: 326 ),
{ 286: }
  ( sym: 284; act: 327 ),
{ 287: }
  ( sym: 264; act: 206 ),
  ( sym: 275; act: 207 ),
  ( sym: 277; act: 208 ),
  ( sym: 279; act: 209 ),
  ( sym: 281; act: 68 ),
  ( sym: 284; act: 210 ),
  ( sym: 287; act: 211 ),
  ( sym: 291; act: 212 ),
  ( sym: 297; act: 213 ),
  ( sym: 303; act: 71 ),
  ( sym: 311; act: 214 ),
  ( sym: 316; act: 215 ),
  ( sym: 317; act: 216 ),
{ 288: }
{ 289: }
{ 290: }
  ( sym: 301; act: 329 ),
{ 291: }
{ 292: }
{ 293: }
{ 294: }
  ( sym: 303; act: 140 ),
  ( sym: 301; act: -188 ),
{ 295: }
  ( sym: 290; act: 142 ),
  ( sym: 301; act: -163 ),
{ 296: }
  ( sym: 260; act: 127 ),
  ( sym: 268; act: 21 ),
  ( sym: 272; act: 22 ),
  ( sym: 274; act: 23 ),
  ( sym: 294; act: 128 ),
  ( sym: 299; act: 129 ),
  ( sym: 312; act: 131 ),
  ( sym: 313; act: 132 ),
  ( sym: 314; act: 28 ),
  ( sym: 319; act: 29 ),
  ( sym: 320; act: 30 ),
  ( sym: 335; act: 34 ),
  ( sym: 300; act: -50 ),
  ( sym: 258; act: -219 ),
  ( sym: 261; act: -219 ),
  ( sym: 263; act: -219 ),
  ( sym: 271; act: -219 ),
  ( sym: 278; act: -219 ),
  ( sym: 281; act: -219 ),
  ( sym: 290; act: -219 ),
  ( sym: 293; act: -219 ),
  ( sym: 303; act: -219 ),
  ( sym: 308; act: -219 ),
  ( sym: 310; act: -219 ),
  ( sym: 318; act: -219 ),
  ( sym: 321; act: -219 ),
  ( sym: 323; act: -219 ),
  ( sym: 324; act: -219 ),
  ( sym: 325; act: -219 ),
  ( sym: 336; act: -219 ),
{ 297: }
  ( sym: 300; act: 331 ),
{ 298: }
{ 299: }
  ( sym: 281; act: 68 ),
  ( sym: 303; act: 71 ),
{ 300: }
  ( sym: 281; act: 68 ),
  ( sym: 303; act: 71 ),
{ 301: }
  ( sym: 267; act: 335 ),
  ( sym: 286; act: -65 ),
  ( sym: 330; act: -65 ),
{ 302: }
  ( sym: 298; act: 337 ),
  ( sym: 269; act: -231 ),
  ( sym: 304; act: -231 ),
{ 303: }
  ( sym: 282; act: 341 ),
  ( sym: 283; act: 342 ),
  ( sym: 295; act: 343 ),
  ( sym: 301; act: 344 ),
{ 304: }
  ( sym: 281; act: 115 ),
{ 305: }
{ 306: }
{ 307: }
{ 308: }
  ( sym: 258; act: 104 ),
  ( sym: 261; act: 63 ),
  ( sym: 263; act: 64 ),
  ( sym: 271; act: 65 ),
  ( sym: 278; act: 67 ),
  ( sym: 281; act: 68 ),
  ( sym: 290; act: 69 ),
  ( sym: 293; act: 70 ),
  ( sym: 303; act: 71 ),
  ( sym: 308; act: 72 ),
  ( sym: 310; act: 73 ),
  ( sym: 318; act: 107 ),
  ( sym: 321; act: 74 ),
  ( sym: 324; act: 75 ),
  ( sym: 325; act: 76 ),
  ( sym: 336; act: 108 ),
{ 309: }
  ( sym: 267; act: 347 ),
  ( sym: 301; act: -75 ),
{ 310: }
  ( sym: 301; act: 348 ),
{ 311: }
{ 312: }
{ 313: }
{ 314: }
{ 315: }
  ( sym: 259; act: 258 ),
  ( sym: 296; act: 259 ),
  ( sym: 309; act: 260 ),
  ( sym: 257; act: -102 ),
  ( sym: 265; act: -102 ),
  ( sym: 266; act: -102 ),
  ( sym: 267; act: -102 ),
  ( sym: 280; act: -102 ),
  ( sym: 291; act: -102 ),
  ( sym: 297; act: -102 ),
  ( sym: 301; act: -102 ),
  ( sym: 302; act: -102 ),
  ( sym: 304; act: -102 ),
  ( sym: 306; act: -102 ),
  ( sym: 307; act: -102 ),
  ( sym: 322; act: -102 ),
{ 316: }
  ( sym: 259; act: 258 ),
  ( sym: 296; act: 259 ),
  ( sym: 309; act: 260 ),
  ( sym: 257; act: -101 ),
  ( sym: 265; act: -101 ),
  ( sym: 266; act: -101 ),
  ( sym: 267; act: -101 ),
  ( sym: 280; act: -101 ),
  ( sym: 291; act: -101 ),
  ( sym: 297; act: -101 ),
  ( sym: 301; act: -101 ),
  ( sym: 302; act: -101 ),
  ( sym: 304; act: -101 ),
  ( sym: 306; act: -101 ),
  ( sym: 307; act: -101 ),
  ( sym: 322; act: -101 ),
{ 317: }
  ( sym: 291; act: 261 ),
  ( sym: 297; act: 262 ),
  ( sym: 257; act: -99 ),
  ( sym: 265; act: -99 ),
  ( sym: 266; act: -99 ),
  ( sym: 267; act: -99 ),
  ( sym: 280; act: -99 ),
  ( sym: 301; act: -99 ),
  ( sym: 302; act: -99 ),
  ( sym: 304; act: -99 ),
  ( sym: 306; act: -99 ),
  ( sym: 307; act: -99 ),
  ( sym: 322; act: -99 ),
{ 318: }
  ( sym: 291; act: 261 ),
  ( sym: 297; act: 262 ),
  ( sym: 257; act: -98 ),
  ( sym: 265; act: -98 ),
  ( sym: 266; act: -98 ),
  ( sym: 267; act: -98 ),
  ( sym: 280; act: -98 ),
  ( sym: 301; act: -98 ),
  ( sym: 302; act: -98 ),
  ( sym: 304; act: -98 ),
  ( sym: 306; act: -98 ),
  ( sym: 307; act: -98 ),
  ( sym: 322; act: -98 ),
{ 319: }
  ( sym: 306; act: 263 ),
  ( sym: 307; act: 264 ),
  ( sym: 257; act: -96 ),
  ( sym: 265; act: -96 ),
  ( sym: 266; act: -96 ),
  ( sym: 267; act: -96 ),
  ( sym: 280; act: -96 ),
  ( sym: 301; act: -96 ),
  ( sym: 302; act: -96 ),
  ( sym: 304; act: -96 ),
  ( sym: 322; act: -96 ),
{ 320: }
  ( sym: 257; act: 265 ),
  ( sym: 265; act: -94 ),
  ( sym: 266; act: -94 ),
  ( sym: 267; act: -94 ),
  ( sym: 280; act: -94 ),
  ( sym: 301; act: -94 ),
  ( sym: 302; act: -94 ),
  ( sym: 304; act: -94 ),
  ( sym: 322; act: -94 ),
{ 321: }
  ( sym: 265; act: 266 ),
  ( sym: 266; act: -92 ),
  ( sym: 267; act: -92 ),
  ( sym: 280; act: -92 ),
  ( sym: 301; act: -92 ),
  ( sym: 302; act: -92 ),
  ( sym: 304; act: -92 ),
  ( sym: 322; act: -92 ),
{ 322: }
{ 323: }
{ 324: }
{ 325: }
{ 326: }
{ 327: }
  ( sym: 280; act: 349 ),
{ 328: }
  ( sym: 280; act: 350 ),
{ 329: }
  ( sym: 286; act: 351 ),
{ 330: }
  ( sym: 300; act: 352 ),
{ 331: }
{ 332: }
{ 333: }
{ 334: }
{ 335: }
  ( sym: 281; act: 68 ),
  ( sym: 303; act: 71 ),
{ 336: }
  ( sym: 269; act: 355 ),
  ( sym: 304; act: -233 ),
{ 337: }
  ( sym: 287; act: 356 ),
{ 338: }
  ( sym: 258; act: 104 ),
  ( sym: 261; act: 63 ),
  ( sym: 263; act: 64 ),
  ( sym: 271; act: 65 ),
  ( sym: 278; act: 67 ),
  ( sym: 281; act: 68 ),
  ( sym: 290; act: 69 ),
  ( sym: 293; act: 70 ),
  ( sym: 303; act: 71 ),
  ( sym: 308; act: 72 ),
  ( sym: 310; act: 73 ),
  ( sym: 318; act: 107 ),
  ( sym: 321; act: 74 ),
  ( sym: 324; act: 75 ),
  ( sym: 325; act: 76 ),
  ( sym: 336; act: 108 ),
{ 339: }
  ( sym: 267; act: 358 ),
  ( sym: 301; act: -225 ),
{ 340: }
  ( sym: 301; act: 359 ),
{ 341: }
{ 342: }
{ 343: }
{ 344: }
{ 345: }
{ 346: }
  ( sym: 281; act: 115 ),
{ 347: }
  ( sym: 282; act: 311 ),
{ 348: }
  ( sym: 304; act: 362 ),
{ 349: }
{ 350: }
{ 351: }
  ( sym: 262; act: 366 ),
  ( sym: 270; act: 367 ),
{ 352: }
{ 353: }
{ 354: }
{ 355: }
  ( sym: 287; act: 368 ),
{ 356: }
  ( sym: 281; act: 68 ),
  ( sym: 303; act: 71 ),
{ 357: }
  ( sym: 281; act: 115 ),
{ 358: }
  ( sym: 282; act: 341 ),
  ( sym: 283; act: 342 ),
  ( sym: 295; act: 343 ),
{ 359: }
{ 360: }
{ 361: }
{ 362: }
{ 363: }
  ( sym: 258; act: 104 ),
  ( sym: 261; act: 63 ),
  ( sym: 262; act: 366 ),
  ( sym: 263; act: 64 ),
  ( sym: 270; act: 367 ),
  ( sym: 271; act: 65 ),
  ( sym: 272; act: 22 ),
  ( sym: 276; act: 105 ),
  ( sym: 278; act: 67 ),
  ( sym: 281; act: 68 ),
  ( sym: 290; act: 69 ),
  ( sym: 293; act: 70 ),
  ( sym: 303; act: 71 ),
  ( sym: 305; act: 106 ),
  ( sym: 308; act: 72 ),
  ( sym: 310; act: 73 ),
  ( sym: 312; act: 375 ),
  ( sym: 314; act: 28 ),
  ( sym: 318; act: 107 ),
  ( sym: 320; act: 30 ),
  ( sym: 321; act: 74 ),
  ( sym: 324; act: 75 ),
  ( sym: 325; act: 76 ),
  ( sym: 336; act: 108 ),
{ 364: }
  ( sym: 262; act: 366 ),
  ( sym: 270; act: 367 ),
  ( sym: 300; act: -189 ),
{ 365: }
  ( sym: 300; act: 377 ),
{ 366: }
  ( sym: 264; act: 206 ),
  ( sym: 275; act: 207 ),
  ( sym: 277; act: 208 ),
  ( sym: 279; act: 209 ),
  ( sym: 281; act: 68 ),
  ( sym: 284; act: 210 ),
  ( sym: 287; act: 211 ),
  ( sym: 291; act: 212 ),
  ( sym: 297; act: 213 ),
  ( sym: 303; act: 71 ),
  ( sym: 311; act: 214 ),
  ( sym: 316; act: 215 ),
  ( sym: 317; act: 216 ),
{ 367: }
  ( sym: 266; act: 379 ),
{ 368: }
  ( sym: 311; act: 214 ),
{ 369: }
  ( sym: 301; act: 382 ),
{ 370: }
{ 371: }
{ 372: }
  ( sym: 304; act: 383 ),
{ 373: }
{ 374: }
  ( sym: 281; act: 159 ),
{ 375: }
  ( sym: 258; act: 104 ),
  ( sym: 261; act: 63 ),
  ( sym: 263; act: 64 ),
  ( sym: 271; act: 65 ),
  ( sym: 272; act: 22 ),
  ( sym: 276; act: 105 ),
  ( sym: 278; act: 67 ),
  ( sym: 281; act: 68 ),
  ( sym: 290; act: 69 ),
  ( sym: 293; act: 70 ),
  ( sym: 303; act: 71 ),
  ( sym: 305; act: 106 ),
  ( sym: 308; act: 72 ),
  ( sym: 310; act: 73 ),
  ( sym: 314; act: 28 ),
  ( sym: 318; act: 107 ),
  ( sym: 320; act: 30 ),
  ( sym: 321; act: 74 ),
  ( sym: 324; act: 75 ),
  ( sym: 325; act: 76 ),
  ( sym: 336; act: 108 ),
{ 376: }
{ 377: }
{ 378: }
  ( sym: 266; act: 386 ),
{ 379: }
{ 380: }
  ( sym: 267; act: 387 ),
  ( sym: 301; act: -235 ),
{ 381: }
  ( sym: 301; act: 388 ),
{ 382: }
{ 383: }
{ 384: }
{ 385: }
  ( sym: 304; act: 389 ),
{ 386: }
{ 387: }
  ( sym: 311; act: 214 )
{ 388: }
{ 389: }
{ 390: }
);

yyg : array [1..yyngotos] of YYARec = (
{ 0: }
  ( sym: -110; act: 1 ),
  ( sym: -93; act: 2 ),
  ( sym: -83; act: 3 ),
  ( sym: -77; act: 4 ),
  ( sym: -71; act: 5 ),
  ( sym: -47; act: 6 ),
  ( sym: -34; act: 7 ),
  ( sym: -23; act: 8 ),
  ( sym: -20; act: 9 ),
  ( sym: -19; act: 10 ),
  ( sym: -18; act: 11 ),
  ( sym: -17; act: 12 ),
  ( sym: -16; act: 13 ),
  ( sym: -8; act: 14 ),
  ( sym: -7; act: 15 ),
  ( sym: -6; act: 16 ),
  ( sym: -5; act: 17 ),
  ( sym: -4; act: 18 ),
  ( sym: -3; act: 19 ),
  ( sym: -2; act: 20 ),
{ 1: }
{ 2: }
{ 3: }
{ 4: }
{ 5: }
{ 6: }
{ 7: }
{ 8: }
{ 9: }
{ 10: }
{ 11: }
{ 12: }
{ 13: }
{ 14: }
{ 15: }
{ 16: }
{ 17: }
{ 18: }
{ 19: }
  ( sym: -93; act: 2 ),
  ( sym: -83; act: 3 ),
  ( sym: -77; act: 4 ),
  ( sym: -71; act: 5 ),
  ( sym: -47; act: 6 ),
  ( sym: -34; act: 7 ),
  ( sym: -23; act: 8 ),
  ( sym: -20; act: 9 ),
  ( sym: -19; act: 10 ),
  ( sym: -18; act: 11 ),
  ( sym: -17; act: 12 ),
  ( sym: -16; act: 13 ),
  ( sym: -8; act: 14 ),
  ( sym: -7; act: 15 ),
  ( sym: -6; act: 16 ),
  ( sym: -5; act: 17 ),
  ( sym: -4; act: 18 ),
  ( sym: -3; act: 19 ),
  ( sym: -2; act: 43 ),
{ 20: }
{ 21: }
  ( sym: -106; act: 44 ),
  ( sym: -88; act: 45 ),
  ( sym: -86; act: 46 ),
  ( sym: -70; act: 47 ),
  ( sym: -69; act: 48 ),
  ( sym: -68; act: 49 ),
  ( sym: -67; act: 50 ),
  ( sym: -66; act: 51 ),
  ( sym: -65; act: 52 ),
  ( sym: -64; act: 53 ),
  ( sym: -63; act: 54 ),
  ( sym: -62; act: 55 ),
  ( sym: -61; act: 56 ),
  ( sym: -60; act: 57 ),
  ( sym: -59; act: 58 ),
  ( sym: -58; act: 59 ),
  ( sym: -57; act: 60 ),
  ( sym: -35; act: 61 ),
  ( sym: -15; act: 62 ),
{ 22: }
{ 23: }
{ 24: }
{ 25: }
{ 26: }
{ 27: }
{ 28: }
{ 29: }
  ( sym: -108; act: 82 ),
  ( sym: -107; act: 83 ),
  ( sym: -88; act: 84 ),
  ( sym: -86; act: 85 ),
  ( sym: -85; act: 86 ),
  ( sym: -83; act: 87 ),
  ( sym: -77; act: 88 ),
  ( sym: -73; act: 89 ),
  ( sym: -72; act: 90 ),
  ( sym: -71; act: 91 ),
  ( sym: -70; act: 92 ),
  ( sym: -69; act: 93 ),
  ( sym: -68; act: 94 ),
  ( sym: -67; act: 95 ),
  ( sym: -66; act: 51 ),
  ( sym: -65; act: 52 ),
  ( sym: -64; act: 53 ),
  ( sym: -63; act: 54 ),
  ( sym: -62; act: 55 ),
  ( sym: -61; act: 56 ),
  ( sym: -60; act: 57 ),
  ( sym: -59; act: 58 ),
  ( sym: -58; act: 96 ),
  ( sym: -57; act: 97 ),
  ( sym: -52; act: 98 ),
  ( sym: -51; act: 99 ),
  ( sym: -50; act: 100 ),
  ( sym: -49; act: 101 ),
  ( sym: -48; act: 102 ),
  ( sym: -15; act: 103 ),
{ 30: }
{ 31: }
{ 32: }
{ 33: }
{ 34: }
  ( sym: -56; act: 114 ),
{ 35: }
{ 36: }
{ 37: }
{ 38: }
  ( sym: -96; act: 116 ),
  ( sym: -95; act: 117 ),
  ( sym: -93; act: 118 ),
  ( sym: -92; act: 119 ),
  ( sym: -83; act: 3 ),
  ( sym: -77; act: 4 ),
  ( sym: -71; act: 5 ),
  ( sym: -47; act: 120 ),
  ( sym: -34; act: 121 ),
  ( sym: -31; act: 122 ),
  ( sym: -29; act: 123 ),
  ( sym: -28; act: 124 ),
  ( sym: -22; act: 125 ),
  ( sym: -11; act: 126 ),
{ 39: }
{ 40: }
  ( sym: -96; act: 116 ),
  ( sym: -95; act: 117 ),
  ( sym: -93; act: 118 ),
  ( sym: -92; act: 119 ),
  ( sym: -83; act: 3 ),
  ( sym: -77; act: 4 ),
  ( sym: -71; act: 5 ),
  ( sym: -47; act: 120 ),
  ( sym: -34; act: 121 ),
  ( sym: -11; act: 136 ),
  ( sym: -10; act: 137 ),
  ( sym: -9; act: 138 ),
{ 41: }
{ 42: }
{ 43: }
{ 44: }
{ 45: }
{ 46: }
{ 47: }
{ 48: }
{ 49: }
{ 50: }
{ 51: }
{ 52: }
{ 53: }
{ 54: }
{ 55: }
{ 56: }
{ 57: }
{ 58: }
{ 59: }
{ 60: }
{ 61: }
{ 62: }
{ 63: }
{ 64: }
{ 65: }
{ 66: }
{ 67: }
{ 68: }
{ 69: }
{ 70: }
{ 71: }
{ 72: }
{ 73: }
{ 74: }
{ 75: }
{ 76: }
{ 77: }
{ 78: }
{ 79: }
  ( sym: -12; act: 150 ),
{ 80: }
{ 81: }
{ 82: }
{ 83: }
{ 84: }
{ 85: }
{ 86: }
{ 87: }
{ 88: }
{ 89: }
{ 90: }
{ 91: }
{ 92: }
{ 93: }
{ 94: }
{ 95: }
{ 96: }
{ 97: }
{ 98: }
{ 99: }
{ 100: }
{ 101: }
  ( sym: -87; act: 154 ),
  ( sym: -56; act: 155 ),
  ( sym: -55; act: 156 ),
  ( sym: -54; act: 157 ),
  ( sym: -53; act: 158 ),
{ 102: }
{ 103: }
{ 104: }
{ 105: }
{ 106: }
{ 107: }
{ 108: }
{ 109: }
{ 110: }
{ 111: }
{ 112: }
  ( sym: -108; act: 82 ),
  ( sym: -107; act: 83 ),
  ( sym: -88; act: 84 ),
  ( sym: -86; act: 85 ),
  ( sym: -85; act: 86 ),
  ( sym: -83; act: 87 ),
  ( sym: -77; act: 88 ),
  ( sym: -73; act: 89 ),
  ( sym: -72; act: 90 ),
  ( sym: -71; act: 91 ),
  ( sym: -70; act: 92 ),
  ( sym: -69; act: 93 ),
  ( sym: -68; act: 94 ),
  ( sym: -67; act: 95 ),
  ( sym: -66; act: 51 ),
  ( sym: -65; act: 52 ),
  ( sym: -64; act: 53 ),
  ( sym: -63; act: 54 ),
  ( sym: -62; act: 55 ),
  ( sym: -61; act: 56 ),
  ( sym: -60; act: 57 ),
  ( sym: -59; act: 58 ),
  ( sym: -58; act: 96 ),
  ( sym: -57; act: 97 ),
  ( sym: -52; act: 98 ),
  ( sym: -51; act: 99 ),
  ( sym: -50; act: 100 ),
  ( sym: -49; act: 165 ),
  ( sym: -48; act: 102 ),
  ( sym: -24; act: 166 ),
  ( sym: -15; act: 103 ),
{ 113: }
{ 114: }
{ 115: }
{ 116: }
{ 117: }
  ( sym: -108; act: 82 ),
  ( sym: -105; act: 171 ),
  ( sym: -98; act: 172 ),
  ( sym: -88; act: 173 ),
  ( sym: -86; act: 174 ),
  ( sym: -73; act: 89 ),
  ( sym: -72; act: 90 ),
  ( sym: -70; act: 92 ),
  ( sym: -69; act: 93 ),
  ( sym: -68; act: 94 ),
  ( sym: -67; act: 95 ),
  ( sym: -66; act: 51 ),
  ( sym: -65; act: 52 ),
  ( sym: -64; act: 53 ),
  ( sym: -63; act: 54 ),
  ( sym: -62; act: 55 ),
  ( sym: -61; act: 56 ),
  ( sym: -60; act: 57 ),
  ( sym: -59; act: 58 ),
  ( sym: -58; act: 96 ),
  ( sym: -57; act: 97 ),
  ( sym: -51; act: 175 ),
  ( sym: -15; act: 176 ),
{ 118: }
{ 119: }
{ 120: }
{ 121: }
{ 122: }
{ 123: }
{ 124: }
  ( sym: -96; act: 116 ),
  ( sym: -95; act: 117 ),
  ( sym: -93; act: 118 ),
  ( sym: -92; act: 119 ),
  ( sym: -83; act: 3 ),
  ( sym: -77; act: 4 ),
  ( sym: -71; act: 5 ),
  ( sym: -47; act: 120 ),
  ( sym: -34; act: 121 ),
  ( sym: -31; act: 122 ),
  ( sym: -29; act: 123 ),
  ( sym: -28; act: 124 ),
  ( sym: -22; act: 182 ),
  ( sym: -11; act: 126 ),
{ 125: }
{ 126: }
{ 127: }
  ( sym: -108; act: 82 ),
  ( sym: -105; act: 184 ),
  ( sym: -88; act: 173 ),
  ( sym: -86; act: 174 ),
  ( sym: -73; act: 89 ),
  ( sym: -72; act: 90 ),
  ( sym: -70; act: 92 ),
  ( sym: -69; act: 93 ),
  ( sym: -68; act: 94 ),
  ( sym: -67; act: 95 ),
  ( sym: -66; act: 51 ),
  ( sym: -65; act: 52 ),
  ( sym: -64; act: 53 ),
  ( sym: -63; act: 54 ),
  ( sym: -62; act: 55 ),
  ( sym: -61; act: 56 ),
  ( sym: -60; act: 57 ),
  ( sym: -59; act: 58 ),
  ( sym: -58; act: 96 ),
  ( sym: -57; act: 97 ),
  ( sym: -51; act: 175 ),
  ( sym: -15; act: 176 ),
{ 128: }
{ 129: }
{ 130: }
{ 131: }
{ 132: }
{ 133: }
  ( sym: -108; act: 82 ),
  ( sym: -107; act: 83 ),
  ( sym: -88; act: 84 ),
  ( sym: -86; act: 85 ),
  ( sym: -85; act: 86 ),
  ( sym: -83; act: 87 ),
  ( sym: -77; act: 88 ),
  ( sym: -73; act: 89 ),
  ( sym: -72; act: 90 ),
  ( sym: -71; act: 91 ),
  ( sym: -70; act: 92 ),
  ( sym: -69; act: 93 ),
  ( sym: -68; act: 94 ),
  ( sym: -67; act: 95 ),
  ( sym: -66; act: 51 ),
  ( sym: -65; act: 52 ),
  ( sym: -64; act: 53 ),
  ( sym: -63; act: 54 ),
  ( sym: -62; act: 55 ),
  ( sym: -61; act: 56 ),
  ( sym: -60; act: 57 ),
  ( sym: -59; act: 58 ),
  ( sym: -58; act: 96 ),
  ( sym: -57; act: 97 ),
  ( sym: -52; act: 98 ),
  ( sym: -51; act: 99 ),
  ( sym: -50; act: 100 ),
  ( sym: -49; act: 186 ),
  ( sym: -48; act: 102 ),
  ( sym: -15; act: 103 ),
{ 134: }
  ( sym: -108; act: 82 ),
  ( sym: -107; act: 83 ),
  ( sym: -88; act: 84 ),
  ( sym: -86; act: 85 ),
  ( sym: -85; act: 86 ),
  ( sym: -83; act: 87 ),
  ( sym: -77; act: 88 ),
  ( sym: -73; act: 89 ),
  ( sym: -72; act: 90 ),
  ( sym: -71; act: 91 ),
  ( sym: -70; act: 92 ),
  ( sym: -69; act: 93 ),
  ( sym: -68; act: 94 ),
  ( sym: -67; act: 95 ),
  ( sym: -66; act: 51 ),
  ( sym: -65; act: 52 ),
  ( sym: -64; act: 53 ),
  ( sym: -63; act: 54 ),
  ( sym: -62; act: 55 ),
  ( sym: -61; act: 56 ),
  ( sym: -60; act: 57 ),
  ( sym: -59; act: 58 ),
  ( sym: -58; act: 96 ),
  ( sym: -57; act: 97 ),
  ( sym: -52; act: 98 ),
  ( sym: -51; act: 99 ),
  ( sym: -50; act: 100 ),
  ( sym: -49; act: 187 ),
  ( sym: -48; act: 102 ),
  ( sym: -15; act: 103 ),
{ 135: }
{ 136: }
  ( sym: -96; act: 116 ),
  ( sym: -95; act: 117 ),
  ( sym: -93; act: 118 ),
  ( sym: -92; act: 119 ),
  ( sym: -83; act: 3 ),
  ( sym: -77; act: 4 ),
  ( sym: -71; act: 5 ),
  ( sym: -47; act: 120 ),
  ( sym: -34; act: 121 ),
  ( sym: -11; act: 136 ),
  ( sym: -10; act: 189 ),
{ 137: }
{ 138: }
{ 139: }
{ 140: }
{ 141: }
{ 142: }
{ 143: }
{ 144: }
  ( sym: -109; act: 193 ),
  ( sym: -46; act: 194 ),
  ( sym: -45; act: 195 ),
  ( sym: -44; act: 196 ),
  ( sym: -43; act: 197 ),
  ( sym: -42; act: 198 ),
  ( sym: -41; act: 199 ),
  ( sym: -40; act: 200 ),
  ( sym: -39; act: 201 ),
  ( sym: -38; act: 202 ),
  ( sym: -37; act: 203 ),
  ( sym: -36; act: 204 ),
  ( sym: -15; act: 205 ),
{ 145: }
{ 146: }
{ 147: }
  ( sym: -109; act: 193 ),
  ( sym: -46; act: 194 ),
  ( sym: -45; act: 218 ),
  ( sym: -44; act: 196 ),
  ( sym: -43; act: 197 ),
  ( sym: -42; act: 198 ),
  ( sym: -41; act: 199 ),
  ( sym: -40; act: 200 ),
  ( sym: -39; act: 201 ),
  ( sym: -38; act: 202 ),
  ( sym: -37; act: 203 ),
  ( sym: -36; act: 204 ),
  ( sym: -15; act: 205 ),
{ 148: }
  ( sym: -84; act: 219 ),
  ( sym: -82; act: 220 ),
{ 149: }
  ( sym: -108; act: 82 ),
  ( sym: -107; act: 83 ),
  ( sym: -94; act: 222 ),
  ( sym: -88; act: 84 ),
  ( sym: -86; act: 85 ),
  ( sym: -85; act: 86 ),
  ( sym: -83; act: 87 ),
  ( sym: -77; act: 88 ),
  ( sym: -75; act: 223 ),
  ( sym: -73; act: 89 ),
  ( sym: -72; act: 90 ),
  ( sym: -71; act: 91 ),
  ( sym: -70; act: 92 ),
  ( sym: -69; act: 93 ),
  ( sym: -68; act: 94 ),
  ( sym: -67; act: 95 ),
  ( sym: -66; act: 51 ),
  ( sym: -65; act: 52 ),
  ( sym: -64; act: 53 ),
  ( sym: -63; act: 54 ),
  ( sym: -62; act: 55 ),
  ( sym: -61; act: 56 ),
  ( sym: -60; act: 57 ),
  ( sym: -59; act: 58 ),
  ( sym: -58; act: 96 ),
  ( sym: -57; act: 97 ),
  ( sym: -52; act: 98 ),
  ( sym: -51; act: 99 ),
  ( sym: -50; act: 100 ),
  ( sym: -49; act: 224 ),
  ( sym: -48; act: 102 ),
  ( sym: -15; act: 103 ),
{ 150: }
{ 151: }
  ( sym: -15; act: 227 ),
  ( sym: -14; act: 228 ),
  ( sym: -13; act: 229 ),
{ 152: }
  ( sym: -93; act: 2 ),
  ( sym: -83; act: 3 ),
  ( sym: -77; act: 4 ),
  ( sym: -71; act: 5 ),
  ( sym: -47; act: 6 ),
  ( sym: -34; act: 7 ),
  ( sym: -23; act: 8 ),
  ( sym: -20; act: 9 ),
  ( sym: -19; act: 10 ),
  ( sym: -18; act: 11 ),
  ( sym: -17; act: 12 ),
  ( sym: -16; act: 13 ),
  ( sym: -8; act: 14 ),
  ( sym: -7; act: 15 ),
  ( sym: -6; act: 16 ),
  ( sym: -5; act: 17 ),
  ( sym: -4; act: 18 ),
  ( sym: -3; act: 19 ),
  ( sym: -2; act: 230 ),
{ 153: }
  ( sym: -108; act: 82 ),
  ( sym: -107; act: 83 ),
  ( sym: -88; act: 84 ),
  ( sym: -86; act: 85 ),
  ( sym: -85; act: 86 ),
  ( sym: -83; act: 87 ),
  ( sym: -77; act: 88 ),
  ( sym: -75; act: 231 ),
  ( sym: -74; act: 232 ),
  ( sym: -73; act: 89 ),
  ( sym: -72; act: 90 ),
  ( sym: -71; act: 91 ),
  ( sym: -70; act: 92 ),
  ( sym: -69; act: 93 ),
  ( sym: -68; act: 94 ),
  ( sym: -67; act: 95 ),
  ( sym: -66; act: 51 ),
  ( sym: -65; act: 52 ),
  ( sym: -64; act: 53 ),
  ( sym: -63; act: 54 ),
  ( sym: -62; act: 55 ),
  ( sym: -61; act: 56 ),
  ( sym: -60; act: 57 ),
  ( sym: -59; act: 58 ),
  ( sym: -58; act: 96 ),
  ( sym: -57; act: 97 ),
  ( sym: -52; act: 98 ),
  ( sym: -51; act: 99 ),
  ( sym: -50; act: 100 ),
  ( sym: -49; act: 224 ),
  ( sym: -48; act: 102 ),
  ( sym: -15; act: 103 ),
{ 154: }
{ 155: }
{ 156: }
{ 157: }
{ 158: }
{ 159: }
  ( sym: -90; act: 234 ),
  ( sym: -89; act: 235 ),
{ 160: }
  ( sym: -109; act: 193 ),
  ( sym: -46; act: 194 ),
  ( sym: -45; act: 237 ),
  ( sym: -44; act: 196 ),
  ( sym: -43; act: 197 ),
  ( sym: -42; act: 198 ),
  ( sym: -41; act: 199 ),
  ( sym: -40; act: 200 ),
  ( sym: -39; act: 201 ),
  ( sym: -38; act: 202 ),
  ( sym: -37; act: 203 ),
  ( sym: -36; act: 204 ),
  ( sym: -15; act: 205 ),
{ 161: }
  ( sym: -108; act: 82 ),
  ( sym: -107; act: 83 ),
  ( sym: -88; act: 84 ),
  ( sym: -86; act: 85 ),
  ( sym: -85; act: 86 ),
  ( sym: -73; act: 89 ),
  ( sym: -72; act: 90 ),
  ( sym: -70; act: 92 ),
  ( sym: -69; act: 93 ),
  ( sym: -68; act: 94 ),
  ( sym: -67; act: 95 ),
  ( sym: -66; act: 51 ),
  ( sym: -65; act: 52 ),
  ( sym: -64; act: 53 ),
  ( sym: -63; act: 54 ),
  ( sym: -62; act: 55 ),
  ( sym: -61; act: 56 ),
  ( sym: -60; act: 57 ),
  ( sym: -59; act: 58 ),
  ( sym: -58; act: 96 ),
  ( sym: -57; act: 97 ),
  ( sym: -51; act: 99 ),
  ( sym: -50; act: 100 ),
  ( sym: -48; act: 238 ),
  ( sym: -15; act: 103 ),
{ 162: }
{ 163: }
  ( sym: -12; act: 240 ),
{ 164: }
  ( sym: -24; act: 241 ),
{ 165: }
{ 166: }
{ 167: }
  ( sym: -27; act: 243 ),
  ( sym: -25; act: 244 ),
  ( sym: -15; act: 245 ),
{ 168: }
  ( sym: -15; act: 227 ),
  ( sym: -14; act: 228 ),
  ( sym: -13; act: 247 ),
{ 169: }
  ( sym: -24; act: 248 ),
{ 170: }
{ 171: }
{ 172: }
{ 173: }
{ 174: }
{ 175: }
{ 176: }
{ 177: }
{ 178: }
{ 179: }
{ 180: }
{ 181: }
{ 182: }
{ 183: }
{ 184: }
  ( sym: -91; act: 250 ),
  ( sym: -56; act: 251 ),
{ 185: }
  ( sym: -108; act: 82 ),
  ( sym: -105; act: 252 ),
  ( sym: -88; act: 173 ),
  ( sym: -86; act: 174 ),
  ( sym: -73; act: 89 ),
  ( sym: -72; act: 90 ),
  ( sym: -70; act: 92 ),
  ( sym: -69; act: 93 ),
  ( sym: -68; act: 94 ),
  ( sym: -67; act: 95 ),
  ( sym: -66; act: 51 ),
  ( sym: -65; act: 52 ),
  ( sym: -64; act: 53 ),
  ( sym: -63; act: 54 ),
  ( sym: -62; act: 55 ),
  ( sym: -61; act: 56 ),
  ( sym: -60; act: 57 ),
  ( sym: -59; act: 58 ),
  ( sym: -58; act: 96 ),
  ( sym: -57; act: 97 ),
  ( sym: -51; act: 175 ),
  ( sym: -15; act: 176 ),
{ 186: }
  ( sym: -87; act: 154 ),
  ( sym: -56; act: 155 ),
  ( sym: -55; act: 156 ),
  ( sym: -54; act: 157 ),
  ( sym: -53; act: 253 ),
{ 187: }
  ( sym: -87; act: 154 ),
  ( sym: -56; act: 155 ),
  ( sym: -55; act: 156 ),
  ( sym: -54; act: 157 ),
  ( sym: -53; act: 254 ),
{ 188: }
{ 189: }
{ 190: }
{ 191: }
  ( sym: -109; act: 193 ),
  ( sym: -46; act: 194 ),
  ( sym: -44; act: 196 ),
  ( sym: -43; act: 197 ),
  ( sym: -42; act: 198 ),
  ( sym: -41; act: 199 ),
  ( sym: -40; act: 200 ),
  ( sym: -39; act: 201 ),
  ( sym: -38; act: 202 ),
  ( sym: -37; act: 203 ),
  ( sym: -36; act: 256 ),
  ( sym: -15; act: 205 ),
{ 192: }
{ 193: }
{ 194: }
{ 195: }
{ 196: }
{ 197: }
{ 198: }
{ 199: }
{ 200: }
{ 201: }
{ 202: }
{ 203: }
{ 204: }
{ 205: }
{ 206: }
{ 207: }
{ 208: }
{ 209: }
{ 210: }
{ 211: }
  ( sym: -109; act: 193 ),
  ( sym: -46; act: 194 ),
  ( sym: -44; act: 196 ),
  ( sym: -43; act: 197 ),
  ( sym: -42; act: 198 ),
  ( sym: -41; act: 199 ),
  ( sym: -40; act: 200 ),
  ( sym: -39; act: 201 ),
  ( sym: -38; act: 202 ),
  ( sym: -37; act: 203 ),
  ( sym: -36; act: 268 ),
  ( sym: -15; act: 205 ),
{ 212: }
  ( sym: -109; act: 193 ),
  ( sym: -46; act: 194 ),
  ( sym: -44; act: 269 ),
  ( sym: -15; act: 205 ),
{ 213: }
  ( sym: -109; act: 193 ),
  ( sym: -46; act: 194 ),
  ( sym: -44; act: 270 ),
  ( sym: -15; act: 205 ),
{ 214: }
  ( sym: -109; act: 271 ),
{ 215: }
  ( sym: -109; act: 193 ),
  ( sym: -46; act: 194 ),
  ( sym: -44; act: 272 ),
  ( sym: -15; act: 205 ),
{ 216: }
{ 217: }
{ 218: }
{ 219: }
{ 220: }
{ 221: }
{ 222: }
{ 223: }
  ( sym: -108; act: 82 ),
  ( sym: -107; act: 83 ),
  ( sym: -94; act: 277 ),
  ( sym: -88; act: 84 ),
  ( sym: -86; act: 85 ),
  ( sym: -85; act: 86 ),
  ( sym: -83; act: 87 ),
  ( sym: -77; act: 88 ),
  ( sym: -75; act: 223 ),
  ( sym: -73; act: 89 ),
  ( sym: -72; act: 90 ),
  ( sym: -71; act: 91 ),
  ( sym: -70; act: 92 ),
  ( sym: -69; act: 93 ),
  ( sym: -68; act: 94 ),
  ( sym: -67; act: 95 ),
  ( sym: -66; act: 51 ),
  ( sym: -65; act: 52 ),
  ( sym: -64; act: 53 ),
  ( sym: -63; act: 54 ),
  ( sym: -62; act: 55 ),
  ( sym: -61; act: 56 ),
  ( sym: -60; act: 57 ),
  ( sym: -59; act: 58 ),
  ( sym: -58; act: 96 ),
  ( sym: -57; act: 97 ),
  ( sym: -52; act: 98 ),
  ( sym: -51; act: 99 ),
  ( sym: -50; act: 100 ),
  ( sym: -49; act: 224 ),
  ( sym: -48; act: 102 ),
  ( sym: -15; act: 103 ),
{ 224: }
  ( sym: -87; act: 154 ),
  ( sym: -56; act: 155 ),
  ( sym: -55; act: 156 ),
  ( sym: -54; act: 157 ),
  ( sym: -53; act: 278 ),
{ 225: }
{ 226: }
{ 227: }
{ 228: }
{ 229: }
{ 230: }
{ 231: }
  ( sym: -108; act: 82 ),
  ( sym: -107; act: 83 ),
  ( sym: -88; act: 84 ),
  ( sym: -86; act: 85 ),
  ( sym: -85; act: 86 ),
  ( sym: -83; act: 87 ),
  ( sym: -77; act: 88 ),
  ( sym: -75; act: 231 ),
  ( sym: -74; act: 281 ),
  ( sym: -73; act: 89 ),
  ( sym: -72; act: 90 ),
  ( sym: -71; act: 91 ),
  ( sym: -70; act: 92 ),
  ( sym: -69; act: 93 ),
  ( sym: -68; act: 94 ),
  ( sym: -67; act: 95 ),
  ( sym: -66; act: 51 ),
  ( sym: -65; act: 52 ),
  ( sym: -64; act: 53 ),
  ( sym: -63; act: 54 ),
  ( sym: -62; act: 55 ),
  ( sym: -61; act: 56 ),
  ( sym: -60; act: 57 ),
  ( sym: -59; act: 58 ),
  ( sym: -58; act: 96 ),
  ( sym: -57; act: 97 ),
  ( sym: -52; act: 98 ),
  ( sym: -51; act: 99 ),
  ( sym: -50; act: 100 ),
  ( sym: -49; act: 224 ),
  ( sym: -48; act: 102 ),
  ( sym: -15; act: 103 ),
{ 232: }
{ 233: }
  ( sym: -87; act: 154 ),
  ( sym: -56; act: 155 ),
  ( sym: -55; act: 156 ),
  ( sym: -54; act: 157 ),
  ( sym: -53; act: 283 ),
{ 234: }
  ( sym: -90; act: 234 ),
  ( sym: -89; act: 284 ),
{ 235: }
{ 236: }
  ( sym: -109; act: 193 ),
  ( sym: -46; act: 194 ),
  ( sym: -45; act: 285 ),
  ( sym: -44; act: 196 ),
  ( sym: -43; act: 197 ),
  ( sym: -42; act: 198 ),
  ( sym: -41; act: 199 ),
  ( sym: -40; act: 200 ),
  ( sym: -39; act: 201 ),
  ( sym: -38; act: 202 ),
  ( sym: -37; act: 203 ),
  ( sym: -36; act: 204 ),
  ( sym: -15; act: 205 ),
{ 237: }
{ 238: }
{ 239: }
  ( sym: -83; act: 289 ),
  ( sym: -76; act: 290 ),
  ( sym: -70; act: 291 ),
  ( sym: -68; act: 292 ),
  ( sym: -66; act: 51 ),
  ( sym: -65; act: 52 ),
  ( sym: -64; act: 53 ),
  ( sym: -63; act: 54 ),
  ( sym: -62; act: 55 ),
  ( sym: -61; act: 56 ),
  ( sym: -60; act: 57 ),
  ( sym: -59; act: 58 ),
  ( sym: -58; act: 293 ),
  ( sym: -15; act: 294 ),
{ 240: }
{ 241: }
{ 242: }
  ( sym: -96; act: 116 ),
  ( sym: -95; act: 117 ),
  ( sym: -93; act: 118 ),
  ( sym: -92; act: 119 ),
  ( sym: -83; act: 3 ),
  ( sym: -77; act: 4 ),
  ( sym: -71; act: 5 ),
  ( sym: -47; act: 120 ),
  ( sym: -34; act: 121 ),
  ( sym: -21; act: 297 ),
  ( sym: -11; act: 136 ),
  ( sym: -10; act: 298 ),
{ 243: }
{ 244: }
{ 245: }
{ 246: }
  ( sym: -27; act: 301 ),
  ( sym: -15; act: 245 ),
{ 247: }
{ 248: }
{ 249: }
  ( sym: -97; act: 302 ),
{ 250: }
{ 251: }
{ 252: }
  ( sym: -91; act: 305 ),
  ( sym: -56; act: 251 ),
{ 253: }
{ 254: }
{ 255: }
  ( sym: -33; act: 308 ),
  ( sym: -32; act: 309 ),
  ( sym: -30; act: 310 ),
{ 256: }
{ 257: }
{ 258: }
  ( sym: -109; act: 193 ),
  ( sym: -46; act: 194 ),
  ( sym: -44; act: 196 ),
  ( sym: -43; act: 312 ),
  ( sym: -15; act: 205 ),
{ 259: }
  ( sym: -109; act: 193 ),
  ( sym: -46; act: 194 ),
  ( sym: -44; act: 196 ),
  ( sym: -43; act: 313 ),
  ( sym: -15; act: 205 ),
{ 260: }
  ( sym: -109; act: 193 ),
  ( sym: -46; act: 194 ),
  ( sym: -44; act: 196 ),
  ( sym: -43; act: 314 ),
  ( sym: -15; act: 205 ),
{ 261: }
  ( sym: -109; act: 193 ),
  ( sym: -46; act: 194 ),
  ( sym: -44; act: 196 ),
  ( sym: -43; act: 197 ),
  ( sym: -42; act: 315 ),
  ( sym: -15; act: 205 ),
{ 262: }
  ( sym: -109; act: 193 ),
  ( sym: -46; act: 194 ),
  ( sym: -44; act: 196 ),
  ( sym: -43; act: 197 ),
  ( sym: -42; act: 316 ),
  ( sym: -15; act: 205 ),
{ 263: }
  ( sym: -109; act: 193 ),
  ( sym: -46; act: 194 ),
  ( sym: -44; act: 196 ),
  ( sym: -43; act: 197 ),
  ( sym: -42; act: 198 ),
  ( sym: -41; act: 317 ),
  ( sym: -15; act: 205 ),
{ 264: }
  ( sym: -109; act: 193 ),
  ( sym: -46; act: 194 ),
  ( sym: -44; act: 196 ),
  ( sym: -43; act: 197 ),
  ( sym: -42; act: 198 ),
  ( sym: -41; act: 318 ),
  ( sym: -15; act: 205 ),
{ 265: }
  ( sym: -109; act: 193 ),
  ( sym: -46; act: 194 ),
  ( sym: -44; act: 196 ),
  ( sym: -43; act: 197 ),
  ( sym: -42; act: 198 ),
  ( sym: -41; act: 199 ),
  ( sym: -40; act: 319 ),
  ( sym: -15; act: 205 ),
{ 266: }
  ( sym: -109; act: 193 ),
  ( sym: -46; act: 194 ),
  ( sym: -44; act: 196 ),
  ( sym: -43; act: 197 ),
  ( sym: -42; act: 198 ),
  ( sym: -41; act: 199 ),
  ( sym: -40; act: 200 ),
  ( sym: -39; act: 320 ),
  ( sym: -15; act: 205 ),
{ 267: }
  ( sym: -109; act: 193 ),
  ( sym: -46; act: 194 ),
  ( sym: -44; act: 196 ),
  ( sym: -43; act: 197 ),
  ( sym: -42; act: 198 ),
  ( sym: -41; act: 199 ),
  ( sym: -40; act: 200 ),
  ( sym: -39; act: 201 ),
  ( sym: -38; act: 321 ),
  ( sym: -15; act: 205 ),
{ 268: }
{ 269: }
{ 270: }
{ 271: }
{ 272: }
{ 273: }
{ 274: }
  ( sym: -84; act: 219 ),
  ( sym: -82; act: 323 ),
{ 275: }
{ 276: }
{ 277: }
{ 278: }
{ 279: }
  ( sym: -15; act: 227 ),
  ( sym: -14; act: 325 ),
{ 280: }
{ 281: }
{ 282: }
{ 283: }
{ 284: }
{ 285: }
{ 286: }
{ 287: }
  ( sym: -109; act: 193 ),
  ( sym: -46; act: 194 ),
  ( sym: -45; act: 328 ),
  ( sym: -44; act: 196 ),
  ( sym: -43; act: 197 ),
  ( sym: -42; act: 198 ),
  ( sym: -41; act: 199 ),
  ( sym: -40; act: 200 ),
  ( sym: -39; act: 201 ),
  ( sym: -38; act: 202 ),
  ( sym: -37; act: 203 ),
  ( sym: -36; act: 204 ),
  ( sym: -15; act: 205 ),
{ 288: }
{ 289: }
{ 290: }
{ 291: }
{ 292: }
{ 293: }
{ 294: }
{ 295: }
{ 296: }
  ( sym: -96; act: 116 ),
  ( sym: -95; act: 117 ),
  ( sym: -93; act: 118 ),
  ( sym: -92; act: 119 ),
  ( sym: -83; act: 3 ),
  ( sym: -77; act: 4 ),
  ( sym: -71; act: 5 ),
  ( sym: -47; act: 120 ),
  ( sym: -34; act: 121 ),
  ( sym: -21; act: 330 ),
  ( sym: -11; act: 136 ),
  ( sym: -10; act: 298 ),
{ 297: }
{ 298: }
{ 299: }
  ( sym: -26; act: 332 ),
  ( sym: -15; act: 227 ),
  ( sym: -14; act: 333 ),
{ 300: }
  ( sym: -15; act: 227 ),
  ( sym: -14; act: 228 ),
  ( sym: -13; act: 334 ),
{ 301: }
{ 302: }
  ( sym: -101; act: 336 ),
{ 303: }
  ( sym: -102; act: 338 ),
  ( sym: -100; act: 339 ),
  ( sym: -99; act: 340 ),
{ 304: }
  ( sym: -91; act: 345 ),
  ( sym: -56; act: 251 ),
{ 305: }
{ 306: }
{ 307: }
{ 308: }
  ( sym: -108; act: 82 ),
  ( sym: -105; act: 346 ),
  ( sym: -88; act: 173 ),
  ( sym: -86; act: 174 ),
  ( sym: -73; act: 89 ),
  ( sym: -72; act: 90 ),
  ( sym: -70; act: 92 ),
  ( sym: -69; act: 93 ),
  ( sym: -68; act: 94 ),
  ( sym: -67; act: 95 ),
  ( sym: -66; act: 51 ),
  ( sym: -65; act: 52 ),
  ( sym: -64; act: 53 ),
  ( sym: -63; act: 54 ),
  ( sym: -62; act: 55 ),
  ( sym: -61; act: 56 ),
  ( sym: -60; act: 57 ),
  ( sym: -59; act: 58 ),
  ( sym: -58; act: 96 ),
  ( sym: -57; act: 97 ),
  ( sym: -51; act: 175 ),
  ( sym: -15; act: 176 ),
{ 309: }
{ 310: }
{ 311: }
{ 312: }
{ 313: }
{ 314: }
{ 315: }
{ 316: }
{ 317: }
{ 318: }
{ 319: }
{ 320: }
{ 321: }
{ 322: }
{ 323: }
{ 324: }
{ 325: }
{ 326: }
{ 327: }
{ 328: }
{ 329: }
{ 330: }
{ 331: }
{ 332: }
{ 333: }
{ 334: }
{ 335: }
  ( sym: -26; act: 353 ),
  ( sym: -15; act: 227 ),
  ( sym: -14; act: 333 ),
{ 336: }
  ( sym: -104; act: 354 ),
{ 337: }
{ 338: }
  ( sym: -108; act: 82 ),
  ( sym: -105; act: 357 ),
  ( sym: -88; act: 173 ),
  ( sym: -86; act: 174 ),
  ( sym: -73; act: 89 ),
  ( sym: -72; act: 90 ),
  ( sym: -70; act: 92 ),
  ( sym: -69; act: 93 ),
  ( sym: -68; act: 94 ),
  ( sym: -67; act: 95 ),
  ( sym: -66; act: 51 ),
  ( sym: -65; act: 52 ),
  ( sym: -64; act: 53 ),
  ( sym: -63; act: 54 ),
  ( sym: -62; act: 55 ),
  ( sym: -61; act: 56 ),
  ( sym: -60; act: 57 ),
  ( sym: -59; act: 58 ),
  ( sym: -58; act: 96 ),
  ( sym: -57; act: 97 ),
  ( sym: -51; act: 175 ),
  ( sym: -15; act: 176 ),
{ 339: }
{ 340: }
{ 341: }
{ 342: }
{ 343: }
{ 344: }
{ 345: }
{ 346: }
  ( sym: -56; act: 360 ),
{ 347: }
  ( sym: -33; act: 308 ),
  ( sym: -32; act: 309 ),
  ( sym: -30; act: 361 ),
{ 348: }
{ 349: }
{ 350: }
{ 351: }
  ( sym: -81; act: 363 ),
  ( sym: -79; act: 364 ),
  ( sym: -78; act: 365 ),
{ 352: }
{ 353: }
{ 354: }
{ 355: }
{ 356: }
  ( sym: -15; act: 227 ),
  ( sym: -14; act: 369 ),
{ 357: }
  ( sym: -56; act: 370 ),
{ 358: }
  ( sym: -102; act: 338 ),
  ( sym: -100; act: 339 ),
  ( sym: -99; act: 371 ),
{ 359: }
{ 360: }
{ 361: }
{ 362: }
{ 363: }
  ( sym: -108; act: 82 ),
  ( sym: -107; act: 83 ),
  ( sym: -88; act: 84 ),
  ( sym: -86; act: 85 ),
  ( sym: -85; act: 86 ),
  ( sym: -83; act: 87 ),
  ( sym: -81; act: 363 ),
  ( sym: -80; act: 372 ),
  ( sym: -79; act: 373 ),
  ( sym: -77; act: 88 ),
  ( sym: -73; act: 89 ),
  ( sym: -72; act: 90 ),
  ( sym: -71; act: 91 ),
  ( sym: -70; act: 92 ),
  ( sym: -69; act: 93 ),
  ( sym: -68; act: 94 ),
  ( sym: -67; act: 95 ),
  ( sym: -66; act: 51 ),
  ( sym: -65; act: 52 ),
  ( sym: -64; act: 53 ),
  ( sym: -63; act: 54 ),
  ( sym: -62; act: 55 ),
  ( sym: -61; act: 56 ),
  ( sym: -60; act: 57 ),
  ( sym: -59; act: 58 ),
  ( sym: -58; act: 96 ),
  ( sym: -57; act: 97 ),
  ( sym: -52; act: 98 ),
  ( sym: -51; act: 99 ),
  ( sym: -50; act: 100 ),
  ( sym: -49; act: 374 ),
  ( sym: -48; act: 102 ),
  ( sym: -15; act: 103 ),
{ 364: }
  ( sym: -81; act: 363 ),
  ( sym: -79; act: 364 ),
  ( sym: -78; act: 376 ),
{ 365: }
{ 366: }
  ( sym: -109; act: 193 ),
  ( sym: -46; act: 194 ),
  ( sym: -44; act: 196 ),
  ( sym: -43; act: 197 ),
  ( sym: -42; act: 198 ),
  ( sym: -41; act: 199 ),
  ( sym: -40; act: 200 ),
  ( sym: -39; act: 201 ),
  ( sym: -38; act: 202 ),
  ( sym: -37; act: 203 ),
  ( sym: -36; act: 378 ),
  ( sym: -15; act: 205 ),
{ 367: }
{ 368: }
  ( sym: -109; act: 380 ),
  ( sym: -103; act: 381 ),
{ 369: }
{ 370: }
{ 371: }
{ 372: }
{ 373: }
{ 374: }
  ( sym: -87; act: 154 ),
  ( sym: -56; act: 155 ),
  ( sym: -55; act: 156 ),
  ( sym: -54; act: 384 ),
{ 375: }
  ( sym: -108; act: 82 ),
  ( sym: -107; act: 83 ),
  ( sym: -88; act: 84 ),
  ( sym: -86; act: 85 ),
  ( sym: -85; act: 86 ),
  ( sym: -83; act: 87 ),
  ( sym: -80; act: 385 ),
  ( sym: -77; act: 88 ),
  ( sym: -73; act: 89 ),
  ( sym: -72; act: 90 ),
  ( sym: -71; act: 91 ),
  ( sym: -70; act: 92 ),
  ( sym: -69; act: 93 ),
  ( sym: -68; act: 94 ),
  ( sym: -67; act: 95 ),
  ( sym: -66; act: 51 ),
  ( sym: -65; act: 52 ),
  ( sym: -64; act: 53 ),
  ( sym: -63; act: 54 ),
  ( sym: -62; act: 55 ),
  ( sym: -61; act: 56 ),
  ( sym: -60; act: 57 ),
  ( sym: -59; act: 58 ),
  ( sym: -58; act: 96 ),
  ( sym: -57; act: 97 ),
  ( sym: -52; act: 98 ),
  ( sym: -51; act: 99 ),
  ( sym: -50; act: 100 ),
  ( sym: -49; act: 374 ),
  ( sym: -48; act: 102 ),
  ( sym: -15; act: 103 ),
{ 376: }
{ 377: }
{ 378: }
{ 379: }
{ 380: }
{ 381: }
{ 382: }
{ 383: }
{ 384: }
{ 385: }
{ 386: }
{ 387: }
  ( sym: -109; act: 380 ),
  ( sym: -103; act: 390 )
{ 388: }
{ 389: }
{ 390: }
);

yyd : array [0..yynstates-1] of Integer = (
{ 0: } 0,
{ 1: } 0,
{ 2: } 0,
{ 3: } -125,
{ 4: } -124,
{ 5: } -123,
{ 6: } 0,
{ 7: } 0,
{ 8: } 0,
{ 9: } -41,
{ 10: } -42,
{ 11: } -43,
{ 12: } 0,
{ 13: } -44,
{ 14: } 0,
{ 15: } -15,
{ 16: } -14,
{ 17: } 0,
{ 18: } 0,
{ 19: } 0,
{ 20: } -2,
{ 21: } 0,
{ 22: } 0,
{ 23: } 0,
{ 24: } 0,
{ 25: } 0,
{ 26: } -11,
{ 27: } -12,
{ 28: } 0,
{ 29: } 0,
{ 30: } 0,
{ 31: } 0,
{ 32: } 0,
{ 33: } 0,
{ 34: } 0,
{ 35: } -7,
{ 36: } -5,
{ 37: } -6,
{ 38: } 0,
{ 39: } -10,
{ 40: } 0,
{ 41: } -8,
{ 42: } -9,
{ 43: } -4,
{ 44: } -87,
{ 45: } -86,
{ 46: } -85,
{ 47: } -83,
{ 48: } -89,
{ 49: } -81,
{ 50: } -82,
{ 51: } -165,
{ 52: } -167,
{ 53: } -158,
{ 54: } -166,
{ 55: } -159,
{ 56: } -161,
{ 57: } -157,
{ 58: } -160,
{ 59: } -80,
{ 60: } -84,
{ 61: } 0,
{ 62: } 0,
{ 63: } -173,
{ 64: } -171,
{ 65: } -155,
{ 66: } -244,
{ 67: } -154,
{ 68: } -38,
{ 69: } 0,
{ 70: } -174,
{ 71: } 0,
{ 72: } -162,
{ 73: } 0,
{ 74: } 0,
{ 75: } -172,
{ 76: } 0,
{ 77: } 0,
{ 78: } 0,
{ 79: } 0,
{ 80: } 0,
{ 81: } 0,
{ 82: } -140,
{ 83: } -144,
{ 84: } -143,
{ 85: } -142,
{ 86: } -141,
{ 87: } -147,
{ 88: } -146,
{ 89: } -138,
{ 90: } -139,
{ 91: } -145,
{ 92: } -136,
{ 93: } -137,
{ 94: } -134,
{ 95: } -135,
{ 96: } -133,
{ 97: } -132,
{ 98: } -128,
{ 99: } -129,
{ 100: } -130,
{ 101: } 0,
{ 102: } -127,
{ 103: } 0,
{ 104: } -175,
{ 105: } 0,
{ 106: } 0,
{ 107: } -176,
{ 108: } -245,
{ 109: } 0,
{ 110: } 0,
{ 111: } 0,
{ 112: } 0,
{ 113: } 0,
{ 114: } -126,
{ 115: } -152,
{ 116: } 0,
{ 117: } 0,
{ 118: } 0,
{ 119: } 0,
{ 120: } 0,
{ 121: } 0,
{ 122: } -71,
{ 123: } -70,
{ 124: } 0,
{ 125: } 0,
{ 126: } -69,
{ 127: } 0,
{ 128: } -220,
{ 129: } 0,
{ 130: } -53,
{ 131: } -32,
{ 132: } -33,
{ 133: } 0,
{ 134: } 0,
{ 135: } 0,
{ 136: } 0,
{ 137: } -24,
{ 138: } 0,
{ 139: } 0,
{ 140: } 0,
{ 141: } -156,
{ 142: } -164,
{ 143: } -39,
{ 144: } 0,
{ 145: } 0,
{ 146: } -168,
{ 147: } 0,
{ 148: } 0,
{ 149: } 0,
{ 150: } -20,
{ 151: } 0,
{ 152: } 0,
{ 153: } 0,
{ 154: } -153,
{ 155: } -150,
{ 156: } -151,
{ 157: } 0,
{ 158: } -122,
{ 159: } 0,
{ 160: } 0,
{ 161: } 0,
{ 162: } 0,
{ 163: } 0,
{ 164: } 0,
{ 165: } -47,
{ 166: } -56,
{ 167: } 0,
{ 168: } 0,
{ 169: } 0,
{ 170: } -31,
{ 171: } -221,
{ 172: } 0,
{ 173: } -241,
{ 174: } -240,
{ 175: } -239,
{ 176: } 0,
{ 177: } -222,
{ 178: } -29,
{ 179: } -30,
{ 180: } -27,
{ 181: } -28,
{ 182: } -55,
{ 183: } -52,
{ 184: } 0,
{ 185: } 0,
{ 186: } 0,
{ 187: } 0,
{ 188: } 0,
{ 189: } -26,
{ 190: } -16,
{ 191: } 0,
{ 192: } -40,
{ 193: } -117,
{ 194: } -112,
{ 195: } 0,
{ 196: } -110,
{ 197: } -103,
{ 198: } 0,
{ 199: } 0,
{ 200: } 0,
{ 201: } 0,
{ 202: } 0,
{ 203: } 0,
{ 204: } -121,
{ 205: } 0,
{ 206: } -118,
{ 207: } -120,
{ 208: } -114,
{ 209: } -115,
{ 210: } -116,
{ 211: } 0,
{ 212: } 0,
{ 213: } 0,
{ 214: } 0,
{ 215: } 0,
{ 216: } -119,
{ 217: } -170,
{ 218: } 0,
{ 219: } 0,
{ 220: } 0,
{ 221: } -200,
{ 222: } 0,
{ 223: } 0,
{ 224: } 0,
{ 225: } -181,
{ 226: } -182,
{ 227: } 0,
{ 228: } -35,
{ 229: } -34,
{ 230: } 0,
{ 231: } 0,
{ 232: } 0,
{ 233: } 0,
{ 234: } 0,
{ 235: } -207,
{ 236: } 0,
{ 237: } 0,
{ 238: } 0,
{ 239: } 0,
{ 240: } -22,
{ 241: } 0,
{ 242: } 0,
{ 243: } 0,
{ 244: } 0,
{ 245: } 0,
{ 246: } 0,
{ 247: } -62,
{ 248: } -57,
{ 249: } 0,
{ 250: } -211,
{ 251: } 0,
{ 252: } 0,
{ 253: } 0,
{ 254: } 0,
{ 255: } 0,
{ 256: } -79,
{ 257: } -203,
{ 258: } 0,
{ 259: } 0,
{ 260: } 0,
{ 261: } 0,
{ 262: } 0,
{ 263: } 0,
{ 264: } 0,
{ 265: } 0,
{ 266: } 0,
{ 267: } 0,
{ 268: } 0,
{ 269: } -107,
{ 270: } -108,
{ 271: } -238,
{ 272: } -109,
{ 273: } -205,
{ 274: } 0,
{ 275: } -197,
{ 276: } -215,
{ 277: } -217,
{ 278: } 0,
{ 279: } 0,
{ 280: } -13,
{ 281: } -179,
{ 282: } -177,
{ 283: } -149,
{ 284: } -209,
{ 285: } 0,
{ 286: } 0,
{ 287: } 0,
{ 288: } -202,
{ 289: } -187,
{ 290: } 0,
{ 291: } -186,
{ 292: } -185,
{ 293: } -184,
{ 294: } 0,
{ 295: } 0,
{ 296: } 0,
{ 297: } 0,
{ 298: } -51,
{ 299: } 0,
{ 300: } 0,
{ 301: } 0,
{ 302: } 0,
{ 303: } 0,
{ 304: } 0,
{ 305: } -212,
{ 306: } -72,
{ 307: } -73,
{ 308: } 0,
{ 309: } 0,
{ 310: } 0,
{ 311: } -78,
{ 312: } -104,
{ 313: } -106,
{ 314: } -105,
{ 315: } 0,
{ 316: } 0,
{ 317: } 0,
{ 318: } 0,
{ 319: } 0,
{ 320: } 0,
{ 321: } 0,
{ 322: } -113,
{ 323: } -199,
{ 324: } -180,
{ 325: } -37,
{ 326: } -210,
{ 327: } 0,
{ 328: } 0,
{ 329: } 0,
{ 330: } 0,
{ 331: } -48,
{ 332: } -64,
{ 333: } -67,
{ 334: } -61,
{ 335: } 0,
{ 336: } 0,
{ 337: } 0,
{ 338: } 0,
{ 339: } 0,
{ 340: } 0,
{ 341: } -228,
{ 342: } -230,
{ 343: } -229,
{ 344: } -224,
{ 345: } -214,
{ 346: } 0,
{ 347: } 0,
{ 348: } 0,
{ 349: } -243,
{ 350: } -201,
{ 351: } 0,
{ 352: } -49,
{ 353: } -66,
{ 354: } -218,
{ 355: } 0,
{ 356: } 0,
{ 357: } 0,
{ 358: } 0,
{ 359: } -223,
{ 360: } -77,
{ 361: } -76,
{ 362: } -74,
{ 363: } 0,
{ 364: } 0,
{ 365: } 0,
{ 366: } 0,
{ 367: } 0,
{ 368: } 0,
{ 369: } 0,
{ 370: } -227,
{ 371: } -226,
{ 372: } 0,
{ 373: } -191,
{ 374: } 0,
{ 375: } 0,
{ 376: } -190,
{ 377: } -183,
{ 378: } 0,
{ 379: } -195,
{ 380: } 0,
{ 381: } 0,
{ 382: } -232,
{ 383: } -192,
{ 384: } -196,
{ 385: } 0,
{ 386: } -194,
{ 387: } 0,
{ 388: } -234,
{ 389: } -193,
{ 390: } -236
);

yyal : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 16,
{ 2: } 17,
{ 3: } 18,
{ 4: } 18,
{ 5: } 18,
{ 6: } 18,
{ 7: } 19,
{ 8: } 20,
{ 9: } 21,
{ 10: } 21,
{ 11: } 21,
{ 12: } 21,
{ 13: } 22,
{ 14: } 22,
{ 15: } 23,
{ 16: } 23,
{ 17: } 23,
{ 18: } 24,
{ 19: } 25,
{ 20: } 41,
{ 21: } 41,
{ 22: } 55,
{ 23: } 56,
{ 24: } 57,
{ 25: } 58,
{ 26: } 59,
{ 27: } 59,
{ 28: } 59,
{ 29: } 60,
{ 30: } 81,
{ 31: } 82,
{ 32: } 84,
{ 33: } 85,
{ 34: } 86,
{ 35: } 87,
{ 36: } 87,
{ 37: } 87,
{ 38: } 87,
{ 39: } 120,
{ 40: } 120,
{ 41: } 150,
{ 42: } 150,
{ 43: } 150,
{ 44: } 150,
{ 45: } 150,
{ 46: } 150,
{ 47: } 150,
{ 48: } 150,
{ 49: } 150,
{ 50: } 150,
{ 51: } 150,
{ 52: } 150,
{ 53: } 150,
{ 54: } 150,
{ 55: } 150,
{ 56: } 150,
{ 57: } 150,
{ 58: } 150,
{ 59: } 150,
{ 60: } 150,
{ 61: } 150,
{ 62: } 151,
{ 63: } 153,
{ 64: } 153,
{ 65: } 153,
{ 66: } 153,
{ 67: } 153,
{ 68: } 153,
{ 69: } 153,
{ 70: } 159,
{ 71: } 159,
{ 72: } 160,
{ 73: } 160,
{ 74: } 165,
{ 75: } 167,
{ 76: } 167,
{ 77: } 172,
{ 78: } 173,
{ 79: } 174,
{ 80: } 177,
{ 81: } 178,
{ 82: } 179,
{ 83: } 179,
{ 84: } 179,
{ 85: } 179,
{ 86: } 179,
{ 87: } 179,
{ 88: } 179,
{ 89: } 179,
{ 90: } 179,
{ 91: } 179,
{ 92: } 179,
{ 93: } 179,
{ 94: } 179,
{ 95: } 179,
{ 96: } 179,
{ 97: } 179,
{ 98: } 179,
{ 99: } 179,
{ 100: } 179,
{ 101: } 179,
{ 102: } 180,
{ 103: } 180,
{ 104: } 185,
{ 105: } 185,
{ 106: } 186,
{ 107: } 187,
{ 108: } 187,
{ 109: } 187,
{ 110: } 188,
{ 111: } 189,
{ 112: } 190,
{ 113: } 215,
{ 114: } 216,
{ 115: } 216,
{ 116: } 216,
{ 117: } 217,
{ 118: } 234,
{ 119: } 235,
{ 120: } 236,
{ 121: } 237,
{ 122: } 238,
{ 123: } 238,
{ 124: } 238,
{ 125: } 271,
{ 126: } 272,
{ 127: } 272,
{ 128: } 288,
{ 129: } 288,
{ 130: } 289,
{ 131: } 289,
{ 132: } 289,
{ 133: } 289,
{ 134: } 310,
{ 135: } 331,
{ 136: } 332,
{ 137: } 362,
{ 138: } 362,
{ 139: } 363,
{ 140: } 364,
{ 141: } 365,
{ 142: } 365,
{ 143: } 365,
{ 144: } 365,
{ 145: } 378,
{ 146: } 384,
{ 147: } 384,
{ 148: } 397,
{ 149: } 398,
{ 150: } 422,
{ 151: } 422,
{ 152: } 424,
{ 153: } 438,
{ 154: } 461,
{ 155: } 461,
{ 156: } 461,
{ 157: } 461,
{ 158: } 463,
{ 159: } 463,
{ 160: } 466,
{ 161: } 479,
{ 162: } 497,
{ 163: } 498,
{ 164: } 501,
{ 165: } 505,
{ 166: } 505,
{ 167: } 505,
{ 168: } 508,
{ 169: } 510,
{ 170: } 513,
{ 171: } 513,
{ 172: } 513,
{ 173: } 514,
{ 174: } 514,
{ 175: } 514,
{ 176: } 514,
{ 177: } 516,
{ 178: } 516,
{ 179: } 516,
{ 180: } 516,
{ 181: } 516,
{ 182: } 516,
{ 183: } 516,
{ 184: } 516,
{ 185: } 517,
{ 186: } 533,
{ 187: } 534,
{ 188: } 535,
{ 189: } 536,
{ 190: } 536,
{ 191: } 536,
{ 192: } 549,
{ 193: } 549,
{ 194: } 549,
{ 195: } 549,
{ 196: } 550,
{ 197: } 550,
{ 198: } 550,
{ 199: } 566,
{ 200: } 579,
{ 201: } 590,
{ 202: } 599,
{ 203: } 607,
{ 204: } 614,
{ 205: } 614,
{ 206: } 631,
{ 207: } 631,
{ 208: } 631,
{ 209: } 631,
{ 210: } 631,
{ 211: } 631,
{ 212: } 644,
{ 213: } 654,
{ 214: } 664,
{ 215: } 681,
{ 216: } 691,
{ 217: } 691,
{ 218: } 691,
{ 219: } 692,
{ 220: } 694,
{ 221: } 695,
{ 222: } 695,
{ 223: } 696,
{ 224: } 720,
{ 225: } 721,
{ 226: } 721,
{ 227: } 721,
{ 228: } 726,
{ 229: } 726,
{ 230: } 726,
{ 231: } 727,
{ 232: } 751,
{ 233: } 752,
{ 234: } 753,
{ 235: } 756,
{ 236: } 756,
{ 237: } 769,
{ 238: } 770,
{ 239: } 772,
{ 240: } 780,
{ 241: } 780,
{ 242: } 781,
{ 243: } 811,
{ 244: } 814,
{ 245: } 816,
{ 246: } 820,
{ 247: } 822,
{ 248: } 822,
{ 249: } 822,
{ 250: } 823,
{ 251: } 823,
{ 252: } 825,
{ 253: } 826,
{ 254: } 827,
{ 255: } 828,
{ 256: } 829,
{ 257: } 829,
{ 258: } 829,
{ 259: } 842,
{ 260: } 855,
{ 261: } 868,
{ 262: } 881,
{ 263: } 894,
{ 264: } 907,
{ 265: } 920,
{ 266: } 933,
{ 267: } 946,
{ 268: } 959,
{ 269: } 960,
{ 270: } 960,
{ 271: } 960,
{ 272: } 960,
{ 273: } 960,
{ 274: } 960,
{ 275: } 961,
{ 276: } 961,
{ 277: } 961,
{ 278: } 961,
{ 279: } 962,
{ 280: } 964,
{ 281: } 964,
{ 282: } 964,
{ 283: } 964,
{ 284: } 964,
{ 285: } 964,
{ 286: } 965,
{ 287: } 966,
{ 288: } 979,
{ 289: } 979,
{ 290: } 979,
{ 291: } 980,
{ 292: } 980,
{ 293: } 980,
{ 294: } 980,
{ 295: } 982,
{ 296: } 984,
{ 297: } 1014,
{ 298: } 1015,
{ 299: } 1015,
{ 300: } 1017,
{ 301: } 1019,
{ 302: } 1022,
{ 303: } 1025,
{ 304: } 1029,
{ 305: } 1030,
{ 306: } 1030,
{ 307: } 1030,
{ 308: } 1030,
{ 309: } 1046,
{ 310: } 1048,
{ 311: } 1049,
{ 312: } 1049,
{ 313: } 1049,
{ 314: } 1049,
{ 315: } 1049,
{ 316: } 1065,
{ 317: } 1081,
{ 318: } 1094,
{ 319: } 1107,
{ 320: } 1118,
{ 321: } 1127,
{ 322: } 1135,
{ 323: } 1135,
{ 324: } 1135,
{ 325: } 1135,
{ 326: } 1135,
{ 327: } 1135,
{ 328: } 1136,
{ 329: } 1137,
{ 330: } 1138,
{ 331: } 1139,
{ 332: } 1139,
{ 333: } 1139,
{ 334: } 1139,
{ 335: } 1139,
{ 336: } 1141,
{ 337: } 1143,
{ 338: } 1144,
{ 339: } 1160,
{ 340: } 1162,
{ 341: } 1163,
{ 342: } 1163,
{ 343: } 1163,
{ 344: } 1163,
{ 345: } 1163,
{ 346: } 1163,
{ 347: } 1164,
{ 348: } 1165,
{ 349: } 1166,
{ 350: } 1166,
{ 351: } 1166,
{ 352: } 1168,
{ 353: } 1168,
{ 354: } 1168,
{ 355: } 1168,
{ 356: } 1169,
{ 357: } 1171,
{ 358: } 1172,
{ 359: } 1175,
{ 360: } 1175,
{ 361: } 1175,
{ 362: } 1175,
{ 363: } 1175,
{ 364: } 1199,
{ 365: } 1202,
{ 366: } 1203,
{ 367: } 1216,
{ 368: } 1217,
{ 369: } 1218,
{ 370: } 1219,
{ 371: } 1219,
{ 372: } 1219,
{ 373: } 1220,
{ 374: } 1220,
{ 375: } 1221,
{ 376: } 1242,
{ 377: } 1242,
{ 378: } 1242,
{ 379: } 1243,
{ 380: } 1243,
{ 381: } 1245,
{ 382: } 1246,
{ 383: } 1246,
{ 384: } 1246,
{ 385: } 1246,
{ 386: } 1247,
{ 387: } 1247,
{ 388: } 1248,
{ 389: } 1248,
{ 390: } 1248
);

yyah : array [0..yynstates-1] of Integer = (
{ 0: } 15,
{ 1: } 16,
{ 2: } 17,
{ 3: } 17,
{ 4: } 17,
{ 5: } 17,
{ 6: } 18,
{ 7: } 19,
{ 8: } 20,
{ 9: } 20,
{ 10: } 20,
{ 11: } 20,
{ 12: } 21,
{ 13: } 21,
{ 14: } 22,
{ 15: } 22,
{ 16: } 22,
{ 17: } 23,
{ 18: } 24,
{ 19: } 40,
{ 20: } 40,
{ 21: } 54,
{ 22: } 55,
{ 23: } 56,
{ 24: } 57,
{ 25: } 58,
{ 26: } 58,
{ 27: } 58,
{ 28: } 59,
{ 29: } 80,
{ 30: } 81,
{ 31: } 83,
{ 32: } 84,
{ 33: } 85,
{ 34: } 86,
{ 35: } 86,
{ 36: } 86,
{ 37: } 86,
{ 38: } 119,
{ 39: } 119,
{ 40: } 149,
{ 41: } 149,
{ 42: } 149,
{ 43: } 149,
{ 44: } 149,
{ 45: } 149,
{ 46: } 149,
{ 47: } 149,
{ 48: } 149,
{ 49: } 149,
{ 50: } 149,
{ 51: } 149,
{ 52: } 149,
{ 53: } 149,
{ 54: } 149,
{ 55: } 149,
{ 56: } 149,
{ 57: } 149,
{ 58: } 149,
{ 59: } 149,
{ 60: } 149,
{ 61: } 150,
{ 62: } 152,
{ 63: } 152,
{ 64: } 152,
{ 65: } 152,
{ 66: } 152,
{ 67: } 152,
{ 68: } 152,
{ 69: } 158,
{ 70: } 158,
{ 71: } 159,
{ 72: } 159,
{ 73: } 164,
{ 74: } 166,
{ 75: } 166,
{ 76: } 171,
{ 77: } 172,
{ 78: } 173,
{ 79: } 176,
{ 80: } 177,
{ 81: } 178,
{ 82: } 178,
{ 83: } 178,
{ 84: } 178,
{ 85: } 178,
{ 86: } 178,
{ 87: } 178,
{ 88: } 178,
{ 89: } 178,
{ 90: } 178,
{ 91: } 178,
{ 92: } 178,
{ 93: } 178,
{ 94: } 178,
{ 95: } 178,
{ 96: } 178,
{ 97: } 178,
{ 98: } 178,
{ 99: } 178,
{ 100: } 178,
{ 101: } 179,
{ 102: } 179,
{ 103: } 184,
{ 104: } 184,
{ 105: } 185,
{ 106: } 186,
{ 107: } 186,
{ 108: } 186,
{ 109: } 187,
{ 110: } 188,
{ 111: } 189,
{ 112: } 214,
{ 113: } 215,
{ 114: } 215,
{ 115: } 215,
{ 116: } 216,
{ 117: } 233,
{ 118: } 234,
{ 119: } 235,
{ 120: } 236,
{ 121: } 237,
{ 122: } 237,
{ 123: } 237,
{ 124: } 270,
{ 125: } 271,
{ 126: } 271,
{ 127: } 287,
{ 128: } 287,
{ 129: } 288,
{ 130: } 288,
{ 131: } 288,
{ 132: } 288,
{ 133: } 309,
{ 134: } 330,
{ 135: } 331,
{ 136: } 361,
{ 137: } 361,
{ 138: } 362,
{ 139: } 363,
{ 140: } 364,
{ 141: } 364,
{ 142: } 364,
{ 143: } 364,
{ 144: } 377,
{ 145: } 383,
{ 146: } 383,
{ 147: } 396,
{ 148: } 397,
{ 149: } 421,
{ 150: } 421,
{ 151: } 423,
{ 152: } 437,
{ 153: } 460,
{ 154: } 460,
{ 155: } 460,
{ 156: } 460,
{ 157: } 462,
{ 158: } 462,
{ 159: } 465,
{ 160: } 478,
{ 161: } 496,
{ 162: } 497,
{ 163: } 500,
{ 164: } 504,
{ 165: } 504,
{ 166: } 504,
{ 167: } 507,
{ 168: } 509,
{ 169: } 512,
{ 170: } 512,
{ 171: } 512,
{ 172: } 513,
{ 173: } 513,
{ 174: } 513,
{ 175: } 513,
{ 176: } 515,
{ 177: } 515,
{ 178: } 515,
{ 179: } 515,
{ 180: } 515,
{ 181: } 515,
{ 182: } 515,
{ 183: } 515,
{ 184: } 516,
{ 185: } 532,
{ 186: } 533,
{ 187: } 534,
{ 188: } 535,
{ 189: } 535,
{ 190: } 535,
{ 191: } 548,
{ 192: } 548,
{ 193: } 548,
{ 194: } 548,
{ 195: } 549,
{ 196: } 549,
{ 197: } 549,
{ 198: } 565,
{ 199: } 578,
{ 200: } 589,
{ 201: } 598,
{ 202: } 606,
{ 203: } 613,
{ 204: } 613,
{ 205: } 630,
{ 206: } 630,
{ 207: } 630,
{ 208: } 630,
{ 209: } 630,
{ 210: } 630,
{ 211: } 643,
{ 212: } 653,
{ 213: } 663,
{ 214: } 680,
{ 215: } 690,
{ 216: } 690,
{ 217: } 690,
{ 218: } 691,
{ 219: } 693,
{ 220: } 694,
{ 221: } 694,
{ 222: } 695,
{ 223: } 719,
{ 224: } 720,
{ 225: } 720,
{ 226: } 720,
{ 227: } 725,
{ 228: } 725,
{ 229: } 725,
{ 230: } 726,
{ 231: } 750,
{ 232: } 751,
{ 233: } 752,
{ 234: } 755,
{ 235: } 755,
{ 236: } 768,
{ 237: } 769,
{ 238: } 771,
{ 239: } 779,
{ 240: } 779,
{ 241: } 780,
{ 242: } 810,
{ 243: } 813,
{ 244: } 815,
{ 245: } 819,
{ 246: } 821,
{ 247: } 821,
{ 248: } 821,
{ 249: } 822,
{ 250: } 822,
{ 251: } 824,
{ 252: } 825,
{ 253: } 826,
{ 254: } 827,
{ 255: } 828,
{ 256: } 828,
{ 257: } 828,
{ 258: } 841,
{ 259: } 854,
{ 260: } 867,
{ 261: } 880,
{ 262: } 893,
{ 263: } 906,
{ 264: } 919,
{ 265: } 932,
{ 266: } 945,
{ 267: } 958,
{ 268: } 959,
{ 269: } 959,
{ 270: } 959,
{ 271: } 959,
{ 272: } 959,
{ 273: } 959,
{ 274: } 960,
{ 275: } 960,
{ 276: } 960,
{ 277: } 960,
{ 278: } 961,
{ 279: } 963,
{ 280: } 963,
{ 281: } 963,
{ 282: } 963,
{ 283: } 963,
{ 284: } 963,
{ 285: } 964,
{ 286: } 965,
{ 287: } 978,
{ 288: } 978,
{ 289: } 978,
{ 290: } 979,
{ 291: } 979,
{ 292: } 979,
{ 293: } 979,
{ 294: } 981,
{ 295: } 983,
{ 296: } 1013,
{ 297: } 1014,
{ 298: } 1014,
{ 299: } 1016,
{ 300: } 1018,
{ 301: } 1021,
{ 302: } 1024,
{ 303: } 1028,
{ 304: } 1029,
{ 305: } 1029,
{ 306: } 1029,
{ 307: } 1029,
{ 308: } 1045,
{ 309: } 1047,
{ 310: } 1048,
{ 311: } 1048,
{ 312: } 1048,
{ 313: } 1048,
{ 314: } 1048,
{ 315: } 1064,
{ 316: } 1080,
{ 317: } 1093,
{ 318: } 1106,
{ 319: } 1117,
{ 320: } 1126,
{ 321: } 1134,
{ 322: } 1134,
{ 323: } 1134,
{ 324: } 1134,
{ 325: } 1134,
{ 326: } 1134,
{ 327: } 1135,
{ 328: } 1136,
{ 329: } 1137,
{ 330: } 1138,
{ 331: } 1138,
{ 332: } 1138,
{ 333: } 1138,
{ 334: } 1138,
{ 335: } 1140,
{ 336: } 1142,
{ 337: } 1143,
{ 338: } 1159,
{ 339: } 1161,
{ 340: } 1162,
{ 341: } 1162,
{ 342: } 1162,
{ 343: } 1162,
{ 344: } 1162,
{ 345: } 1162,
{ 346: } 1163,
{ 347: } 1164,
{ 348: } 1165,
{ 349: } 1165,
{ 350: } 1165,
{ 351: } 1167,
{ 352: } 1167,
{ 353: } 1167,
{ 354: } 1167,
{ 355: } 1168,
{ 356: } 1170,
{ 357: } 1171,
{ 358: } 1174,
{ 359: } 1174,
{ 360: } 1174,
{ 361: } 1174,
{ 362: } 1174,
{ 363: } 1198,
{ 364: } 1201,
{ 365: } 1202,
{ 366: } 1215,
{ 367: } 1216,
{ 368: } 1217,
{ 369: } 1218,
{ 370: } 1218,
{ 371: } 1218,
{ 372: } 1219,
{ 373: } 1219,
{ 374: } 1220,
{ 375: } 1241,
{ 376: } 1241,
{ 377: } 1241,
{ 378: } 1242,
{ 379: } 1242,
{ 380: } 1244,
{ 381: } 1245,
{ 382: } 1245,
{ 383: } 1245,
{ 384: } 1245,
{ 385: } 1246,
{ 386: } 1246,
{ 387: } 1247,
{ 388: } 1247,
{ 389: } 1247,
{ 390: } 1247
);

yygl : array [0..yynstates-1] of Integer = (
{ 0: } 1,
{ 1: } 21,
{ 2: } 21,
{ 3: } 21,
{ 4: } 21,
{ 5: } 21,
{ 6: } 21,
{ 7: } 21,
{ 8: } 21,
{ 9: } 21,
{ 10: } 21,
{ 11: } 21,
{ 12: } 21,
{ 13: } 21,
{ 14: } 21,
{ 15: } 21,
{ 16: } 21,
{ 17: } 21,
{ 18: } 21,
{ 19: } 21,
{ 20: } 40,
{ 21: } 40,
{ 22: } 59,
{ 23: } 59,
{ 24: } 59,
{ 25: } 59,
{ 26: } 59,
{ 27: } 59,
{ 28: } 59,
{ 29: } 59,
{ 30: } 89,
{ 31: } 89,
{ 32: } 89,
{ 33: } 89,
{ 34: } 89,
{ 35: } 90,
{ 36: } 90,
{ 37: } 90,
{ 38: } 90,
{ 39: } 104,
{ 40: } 104,
{ 41: } 116,
{ 42: } 116,
{ 43: } 116,
{ 44: } 116,
{ 45: } 116,
{ 46: } 116,
{ 47: } 116,
{ 48: } 116,
{ 49: } 116,
{ 50: } 116,
{ 51: } 116,
{ 52: } 116,
{ 53: } 116,
{ 54: } 116,
{ 55: } 116,
{ 56: } 116,
{ 57: } 116,
{ 58: } 116,
{ 59: } 116,
{ 60: } 116,
{ 61: } 116,
{ 62: } 116,
{ 63: } 116,
{ 64: } 116,
{ 65: } 116,
{ 66: } 116,
{ 67: } 116,
{ 68: } 116,
{ 69: } 116,
{ 70: } 116,
{ 71: } 116,
{ 72: } 116,
{ 73: } 116,
{ 74: } 116,
{ 75: } 116,
{ 76: } 116,
{ 77: } 116,
{ 78: } 116,
{ 79: } 116,
{ 80: } 117,
{ 81: } 117,
{ 82: } 117,
{ 83: } 117,
{ 84: } 117,
{ 85: } 117,
{ 86: } 117,
{ 87: } 117,
{ 88: } 117,
{ 89: } 117,
{ 90: } 117,
{ 91: } 117,
{ 92: } 117,
{ 93: } 117,
{ 94: } 117,
{ 95: } 117,
{ 96: } 117,
{ 97: } 117,
{ 98: } 117,
{ 99: } 117,
{ 100: } 117,
{ 101: } 117,
{ 102: } 122,
{ 103: } 122,
{ 104: } 122,
{ 105: } 122,
{ 106: } 122,
{ 107: } 122,
{ 108: } 122,
{ 109: } 122,
{ 110: } 122,
{ 111: } 122,
{ 112: } 122,
{ 113: } 153,
{ 114: } 153,
{ 115: } 153,
{ 116: } 153,
{ 117: } 153,
{ 118: } 176,
{ 119: } 176,
{ 120: } 176,
{ 121: } 176,
{ 122: } 176,
{ 123: } 176,
{ 124: } 176,
{ 125: } 190,
{ 126: } 190,
{ 127: } 190,
{ 128: } 212,
{ 129: } 212,
{ 130: } 212,
{ 131: } 212,
{ 132: } 212,
{ 133: } 212,
{ 134: } 242,
{ 135: } 272,
{ 136: } 272,
{ 137: } 283,
{ 138: } 283,
{ 139: } 283,
{ 140: } 283,
{ 141: } 283,
{ 142: } 283,
{ 143: } 283,
{ 144: } 283,
{ 145: } 296,
{ 146: } 296,
{ 147: } 296,
{ 148: } 309,
{ 149: } 311,
{ 150: } 343,
{ 151: } 343,
{ 152: } 346,
{ 153: } 365,
{ 154: } 397,
{ 155: } 397,
{ 156: } 397,
{ 157: } 397,
{ 158: } 397,
{ 159: } 397,
{ 160: } 399,
{ 161: } 412,
{ 162: } 437,
{ 163: } 437,
{ 164: } 438,
{ 165: } 439,
{ 166: } 439,
{ 167: } 439,
{ 168: } 442,
{ 169: } 445,
{ 170: } 446,
{ 171: } 446,
{ 172: } 446,
{ 173: } 446,
{ 174: } 446,
{ 175: } 446,
{ 176: } 446,
{ 177: } 446,
{ 178: } 446,
{ 179: } 446,
{ 180: } 446,
{ 181: } 446,
{ 182: } 446,
{ 183: } 446,
{ 184: } 446,
{ 185: } 448,
{ 186: } 470,
{ 187: } 475,
{ 188: } 480,
{ 189: } 480,
{ 190: } 480,
{ 191: } 480,
{ 192: } 492,
{ 193: } 492,
{ 194: } 492,
{ 195: } 492,
{ 196: } 492,
{ 197: } 492,
{ 198: } 492,
{ 199: } 492,
{ 200: } 492,
{ 201: } 492,
{ 202: } 492,
{ 203: } 492,
{ 204: } 492,
{ 205: } 492,
{ 206: } 492,
{ 207: } 492,
{ 208: } 492,
{ 209: } 492,
{ 210: } 492,
{ 211: } 492,
{ 212: } 504,
{ 213: } 508,
{ 214: } 512,
{ 215: } 513,
{ 216: } 517,
{ 217: } 517,
{ 218: } 517,
{ 219: } 517,
{ 220: } 517,
{ 221: } 517,
{ 222: } 517,
{ 223: } 517,
{ 224: } 549,
{ 225: } 554,
{ 226: } 554,
{ 227: } 554,
{ 228: } 554,
{ 229: } 554,
{ 230: } 554,
{ 231: } 554,
{ 232: } 586,
{ 233: } 586,
{ 234: } 591,
{ 235: } 593,
{ 236: } 593,
{ 237: } 606,
{ 238: } 606,
{ 239: } 606,
{ 240: } 620,
{ 241: } 620,
{ 242: } 620,
{ 243: } 632,
{ 244: } 632,
{ 245: } 632,
{ 246: } 632,
{ 247: } 634,
{ 248: } 634,
{ 249: } 634,
{ 250: } 635,
{ 251: } 635,
{ 252: } 635,
{ 253: } 637,
{ 254: } 637,
{ 255: } 637,
{ 256: } 640,
{ 257: } 640,
{ 258: } 640,
{ 259: } 645,
{ 260: } 650,
{ 261: } 655,
{ 262: } 661,
{ 263: } 667,
{ 264: } 674,
{ 265: } 681,
{ 266: } 689,
{ 267: } 698,
{ 268: } 708,
{ 269: } 708,
{ 270: } 708,
{ 271: } 708,
{ 272: } 708,
{ 273: } 708,
{ 274: } 708,
{ 275: } 710,
{ 276: } 710,
{ 277: } 710,
{ 278: } 710,
{ 279: } 710,
{ 280: } 712,
{ 281: } 712,
{ 282: } 712,
{ 283: } 712,
{ 284: } 712,
{ 285: } 712,
{ 286: } 712,
{ 287: } 712,
{ 288: } 725,
{ 289: } 725,
{ 290: } 725,
{ 291: } 725,
{ 292: } 725,
{ 293: } 725,
{ 294: } 725,
{ 295: } 725,
{ 296: } 725,
{ 297: } 737,
{ 298: } 737,
{ 299: } 737,
{ 300: } 740,
{ 301: } 743,
{ 302: } 743,
{ 303: } 744,
{ 304: } 747,
{ 305: } 749,
{ 306: } 749,
{ 307: } 749,
{ 308: } 749,
{ 309: } 771,
{ 310: } 771,
{ 311: } 771,
{ 312: } 771,
{ 313: } 771,
{ 314: } 771,
{ 315: } 771,
{ 316: } 771,
{ 317: } 771,
{ 318: } 771,
{ 319: } 771,
{ 320: } 771,
{ 321: } 771,
{ 322: } 771,
{ 323: } 771,
{ 324: } 771,
{ 325: } 771,
{ 326: } 771,
{ 327: } 771,
{ 328: } 771,
{ 329: } 771,
{ 330: } 771,
{ 331: } 771,
{ 332: } 771,
{ 333: } 771,
{ 334: } 771,
{ 335: } 771,
{ 336: } 774,
{ 337: } 775,
{ 338: } 775,
{ 339: } 797,
{ 340: } 797,
{ 341: } 797,
{ 342: } 797,
{ 343: } 797,
{ 344: } 797,
{ 345: } 797,
{ 346: } 797,
{ 347: } 798,
{ 348: } 801,
{ 349: } 801,
{ 350: } 801,
{ 351: } 801,
{ 352: } 804,
{ 353: } 804,
{ 354: } 804,
{ 355: } 804,
{ 356: } 804,
{ 357: } 806,
{ 358: } 807,
{ 359: } 810,
{ 360: } 810,
{ 361: } 810,
{ 362: } 810,
{ 363: } 810,
{ 364: } 843,
{ 365: } 846,
{ 366: } 846,
{ 367: } 858,
{ 368: } 858,
{ 369: } 860,
{ 370: } 860,
{ 371: } 860,
{ 372: } 860,
{ 373: } 860,
{ 374: } 860,
{ 375: } 864,
{ 376: } 895,
{ 377: } 895,
{ 378: } 895,
{ 379: } 895,
{ 380: } 895,
{ 381: } 895,
{ 382: } 895,
{ 383: } 895,
{ 384: } 895,
{ 385: } 895,
{ 386: } 895,
{ 387: } 895,
{ 388: } 897,
{ 389: } 897,
{ 390: } 897
);

yygh : array [0..yynstates-1] of Integer = (
{ 0: } 20,
{ 1: } 20,
{ 2: } 20,
{ 3: } 20,
{ 4: } 20,
{ 5: } 20,
{ 6: } 20,
{ 7: } 20,
{ 8: } 20,
{ 9: } 20,
{ 10: } 20,
{ 11: } 20,
{ 12: } 20,
{ 13: } 20,
{ 14: } 20,
{ 15: } 20,
{ 16: } 20,
{ 17: } 20,
{ 18: } 20,
{ 19: } 39,
{ 20: } 39,
{ 21: } 58,
{ 22: } 58,
{ 23: } 58,
{ 24: } 58,
{ 25: } 58,
{ 26: } 58,
{ 27: } 58,
{ 28: } 58,
{ 29: } 88,
{ 30: } 88,
{ 31: } 88,
{ 32: } 88,
{ 33: } 88,
{ 34: } 89,
{ 35: } 89,
{ 36: } 89,
{ 37: } 89,
{ 38: } 103,
{ 39: } 103,
{ 40: } 115,
{ 41: } 115,
{ 42: } 115,
{ 43: } 115,
{ 44: } 115,
{ 45: } 115,
{ 46: } 115,
{ 47: } 115,
{ 48: } 115,
{ 49: } 115,
{ 50: } 115,
{ 51: } 115,
{ 52: } 115,
{ 53: } 115,
{ 54: } 115,
{ 55: } 115,
{ 56: } 115,
{ 57: } 115,
{ 58: } 115,
{ 59: } 115,
{ 60: } 115,
{ 61: } 115,
{ 62: } 115,
{ 63: } 115,
{ 64: } 115,
{ 65: } 115,
{ 66: } 115,
{ 67: } 115,
{ 68: } 115,
{ 69: } 115,
{ 70: } 115,
{ 71: } 115,
{ 72: } 115,
{ 73: } 115,
{ 74: } 115,
{ 75: } 115,
{ 76: } 115,
{ 77: } 115,
{ 78: } 115,
{ 79: } 116,
{ 80: } 116,
{ 81: } 116,
{ 82: } 116,
{ 83: } 116,
{ 84: } 116,
{ 85: } 116,
{ 86: } 116,
{ 87: } 116,
{ 88: } 116,
{ 89: } 116,
{ 90: } 116,
{ 91: } 116,
{ 92: } 116,
{ 93: } 116,
{ 94: } 116,
{ 95: } 116,
{ 96: } 116,
{ 97: } 116,
{ 98: } 116,
{ 99: } 116,
{ 100: } 116,
{ 101: } 121,
{ 102: } 121,
{ 103: } 121,
{ 104: } 121,
{ 105: } 121,
{ 106: } 121,
{ 107: } 121,
{ 108: } 121,
{ 109: } 121,
{ 110: } 121,
{ 111: } 121,
{ 112: } 152,
{ 113: } 152,
{ 114: } 152,
{ 115: } 152,
{ 116: } 152,
{ 117: } 175,
{ 118: } 175,
{ 119: } 175,
{ 120: } 175,
{ 121: } 175,
{ 122: } 175,
{ 123: } 175,
{ 124: } 189,
{ 125: } 189,
{ 126: } 189,
{ 127: } 211,
{ 128: } 211,
{ 129: } 211,
{ 130: } 211,
{ 131: } 211,
{ 132: } 211,
{ 133: } 241,
{ 134: } 271,
{ 135: } 271,
{ 136: } 282,
{ 137: } 282,
{ 138: } 282,
{ 139: } 282,
{ 140: } 282,
{ 141: } 282,
{ 142: } 282,
{ 143: } 282,
{ 144: } 295,
{ 145: } 295,
{ 146: } 295,
{ 147: } 308,
{ 148: } 310,
{ 149: } 342,
{ 150: } 342,
{ 151: } 345,
{ 152: } 364,
{ 153: } 396,
{ 154: } 396,
{ 155: } 396,
{ 156: } 396,
{ 157: } 396,
{ 158: } 396,
{ 159: } 398,
{ 160: } 411,
{ 161: } 436,
{ 162: } 436,
{ 163: } 437,
{ 164: } 438,
{ 165: } 438,
{ 166: } 438,
{ 167: } 441,
{ 168: } 444,
{ 169: } 445,
{ 170: } 445,
{ 171: } 445,
{ 172: } 445,
{ 173: } 445,
{ 174: } 445,
{ 175: } 445,
{ 176: } 445,
{ 177: } 445,
{ 178: } 445,
{ 179: } 445,
{ 180: } 445,
{ 181: } 445,
{ 182: } 445,
{ 183: } 445,
{ 184: } 447,
{ 185: } 469,
{ 186: } 474,
{ 187: } 479,
{ 188: } 479,
{ 189: } 479,
{ 190: } 479,
{ 191: } 491,
{ 192: } 491,
{ 193: } 491,
{ 194: } 491,
{ 195: } 491,
{ 196: } 491,
{ 197: } 491,
{ 198: } 491,
{ 199: } 491,
{ 200: } 491,
{ 201: } 491,
{ 202: } 491,
{ 203: } 491,
{ 204: } 491,
{ 205: } 491,
{ 206: } 491,
{ 207: } 491,
{ 208: } 491,
{ 209: } 491,
{ 210: } 491,
{ 211: } 503,
{ 212: } 507,
{ 213: } 511,
{ 214: } 512,
{ 215: } 516,
{ 216: } 516,
{ 217: } 516,
{ 218: } 516,
{ 219: } 516,
{ 220: } 516,
{ 221: } 516,
{ 222: } 516,
{ 223: } 548,
{ 224: } 553,
{ 225: } 553,
{ 226: } 553,
{ 227: } 553,
{ 228: } 553,
{ 229: } 553,
{ 230: } 553,
{ 231: } 585,
{ 232: } 585,
{ 233: } 590,
{ 234: } 592,
{ 235: } 592,
{ 236: } 605,
{ 237: } 605,
{ 238: } 605,
{ 239: } 619,
{ 240: } 619,
{ 241: } 619,
{ 242: } 631,
{ 243: } 631,
{ 244: } 631,
{ 245: } 631,
{ 246: } 633,
{ 247: } 633,
{ 248: } 633,
{ 249: } 634,
{ 250: } 634,
{ 251: } 634,
{ 252: } 636,
{ 253: } 636,
{ 254: } 636,
{ 255: } 639,
{ 256: } 639,
{ 257: } 639,
{ 258: } 644,
{ 259: } 649,
{ 260: } 654,
{ 261: } 660,
{ 262: } 666,
{ 263: } 673,
{ 264: } 680,
{ 265: } 688,
{ 266: } 697,
{ 267: } 707,
{ 268: } 707,
{ 269: } 707,
{ 270: } 707,
{ 271: } 707,
{ 272: } 707,
{ 273: } 707,
{ 274: } 709,
{ 275: } 709,
{ 276: } 709,
{ 277: } 709,
{ 278: } 709,
{ 279: } 711,
{ 280: } 711,
{ 281: } 711,
{ 282: } 711,
{ 283: } 711,
{ 284: } 711,
{ 285: } 711,
{ 286: } 711,
{ 287: } 724,
{ 288: } 724,
{ 289: } 724,
{ 290: } 724,
{ 291: } 724,
{ 292: } 724,
{ 293: } 724,
{ 294: } 724,
{ 295: } 724,
{ 296: } 736,
{ 297: } 736,
{ 298: } 736,
{ 299: } 739,
{ 300: } 742,
{ 301: } 742,
{ 302: } 743,
{ 303: } 746,
{ 304: } 748,
{ 305: } 748,
{ 306: } 748,
{ 307: } 748,
{ 308: } 770,
{ 309: } 770,
{ 310: } 770,
{ 311: } 770,
{ 312: } 770,
{ 313: } 770,
{ 314: } 770,
{ 315: } 770,
{ 316: } 770,
{ 317: } 770,
{ 318: } 770,
{ 319: } 770,
{ 320: } 770,
{ 321: } 770,
{ 322: } 770,
{ 323: } 770,
{ 324: } 770,
{ 325: } 770,
{ 326: } 770,
{ 327: } 770,
{ 328: } 770,
{ 329: } 770,
{ 330: } 770,
{ 331: } 770,
{ 332: } 770,
{ 333: } 770,
{ 334: } 770,
{ 335: } 773,
{ 336: } 774,
{ 337: } 774,
{ 338: } 796,
{ 339: } 796,
{ 340: } 796,
{ 341: } 796,
{ 342: } 796,
{ 343: } 796,
{ 344: } 796,
{ 345: } 796,
{ 346: } 797,
{ 347: } 800,
{ 348: } 800,
{ 349: } 800,
{ 350: } 800,
{ 351: } 803,
{ 352: } 803,
{ 353: } 803,
{ 354: } 803,
{ 355: } 803,
{ 356: } 805,
{ 357: } 806,
{ 358: } 809,
{ 359: } 809,
{ 360: } 809,
{ 361: } 809,
{ 362: } 809,
{ 363: } 842,
{ 364: } 845,
{ 365: } 845,
{ 366: } 857,
{ 367: } 857,
{ 368: } 859,
{ 369: } 859,
{ 370: } 859,
{ 371: } 859,
{ 372: } 859,
{ 373: } 859,
{ 374: } 863,
{ 375: } 894,
{ 376: } 894,
{ 377: } 894,
{ 378: } 894,
{ 379: } 894,
{ 380: } 894,
{ 381: } 894,
{ 382: } 894,
{ 383: } 894,
{ 384: } 894,
{ 385: } 894,
{ 386: } 894,
{ 387: } 896,
{ 388: } 896,
{ 389: } 896,
{ 390: } 896
);

yyr : array [1..yynrules] of YYRRec = (
{ 1: } ( len: 0; sym: -110 ),
{ 2: } ( len: 1; sym: -110 ),
{ 3: } ( len: 1; sym: -2 ),
{ 4: } ( len: 2; sym: -2 ),
{ 5: } ( len: 2; sym: -3 ),
{ 6: } ( len: 2; sym: -3 ),
{ 7: } ( len: 2; sym: -3 ),
{ 8: } ( len: 2; sym: -3 ),
{ 9: } ( len: 2; sym: -3 ),
{ 10: } ( len: 2; sym: -3 ),
{ 11: } ( len: 1; sym: -3 ),
{ 12: } ( len: 1; sym: -3 ),
{ 13: } ( len: 5; sym: -4 ),
{ 14: } ( len: 1; sym: -5 ),
{ 15: } ( len: 1; sym: -5 ),
{ 16: } ( len: 4; sym: -6 ),
{ 17: } ( len: 2; sym: -7 ),
{ 18: } ( len: 3; sym: -7 ),
{ 19: } ( len: 2; sym: -8 ),
{ 20: } ( len: 3; sym: -8 ),
{ 21: } ( len: 3; sym: -8 ),
{ 22: } ( len: 4; sym: -8 ),
{ 23: } ( len: 0; sym: -9 ),
{ 24: } ( len: 1; sym: -9 ),
{ 25: } ( len: 1; sym: -10 ),
{ 26: } ( len: 2; sym: -10 ),
{ 27: } ( len: 2; sym: -11 ),
{ 28: } ( len: 2; sym: -11 ),
{ 29: } ( len: 2; sym: -11 ),
{ 30: } ( len: 2; sym: -11 ),
{ 31: } ( len: 2; sym: -11 ),
{ 32: } ( len: 1; sym: -11 ),
{ 33: } ( len: 1; sym: -11 ),
{ 34: } ( len: 2; sym: -12 ),
{ 35: } ( len: 1; sym: -13 ),
{ 36: } ( len: 1; sym: -14 ),
{ 37: } ( len: 3; sym: -14 ),
{ 38: } ( len: 1; sym: -15 ),
{ 39: } ( len: 2; sym: -15 ),
{ 40: } ( len: 3; sym: -15 ),
{ 41: } ( len: 1; sym: -17 ),
{ 42: } ( len: 1; sym: -17 ),
{ 43: } ( len: 1; sym: -17 ),
{ 44: } ( len: 1; sym: -17 ),
{ 45: } ( len: 2; sym: -16 ),
{ 46: } ( len: 3; sym: -16 ),
{ 47: } ( len: 3; sym: -18 ),
{ 48: } ( len: 6; sym: -19 ),
{ 49: } ( len: 7; sym: -19 ),
{ 50: } ( len: 0; sym: -21 ),
{ 51: } ( len: 1; sym: -21 ),
{ 52: } ( len: 4; sym: -20 ),
{ 53: } ( len: 3; sym: -20 ),
{ 54: } ( len: 1; sym: -22 ),
{ 55: } ( len: 2; sym: -22 ),
{ 56: } ( len: 3; sym: -23 ),
{ 57: } ( len: 4; sym: -23 ),
{ 58: } ( len: 2; sym: -23 ),
{ 59: } ( len: 3; sym: -23 ),
{ 60: } ( len: 2; sym: -24 ),
{ 61: } ( len: 4; sym: -24 ),
{ 62: } ( len: 2; sym: -24 ),
{ 63: } ( len: 1; sym: -25 ),
{ 64: } ( len: 3; sym: -25 ),
{ 65: } ( len: 2; sym: -25 ),
{ 66: } ( len: 4; sym: -25 ),
{ 67: } ( len: 1; sym: -26 ),
{ 68: } ( len: 1; sym: -27 ),
{ 69: } ( len: 1; sym: -28 ),
{ 70: } ( len: 1; sym: -28 ),
{ 71: } ( len: 1; sym: -28 ),
{ 72: } ( len: 4; sym: -29 ),
{ 73: } ( len: 4; sym: -29 ),
{ 74: } ( len: 6; sym: -31 ),
{ 75: } ( len: 1; sym: -30 ),
{ 76: } ( len: 3; sym: -30 ),
{ 77: } ( len: 3; sym: -32 ),
{ 78: } ( len: 1; sym: -33 ),
{ 79: } ( len: 5; sym: -34 ),
{ 80: } ( len: 1; sym: -35 ),
{ 81: } ( len: 1; sym: -35 ),
{ 82: } ( len: 1; sym: -35 ),
{ 83: } ( len: 1; sym: -35 ),
{ 84: } ( len: 1; sym: -35 ),
{ 85: } ( len: 1; sym: -35 ),
{ 86: } ( len: 1; sym: -35 ),
{ 87: } ( len: 1; sym: -35 ),
{ 88: } ( len: 1; sym: -35 ),
{ 89: } ( len: 1; sym: -35 ),
{ 90: } ( len: 1; sym: -36 ),
{ 91: } ( len: 1; sym: -37 ),
{ 92: } ( len: 3; sym: -37 ),
{ 93: } ( len: 1; sym: -38 ),
{ 94: } ( len: 3; sym: -38 ),
{ 95: } ( len: 1; sym: -39 ),
{ 96: } ( len: 3; sym: -39 ),
{ 97: } ( len: 1; sym: -40 ),
{ 98: } ( len: 3; sym: -40 ),
{ 99: } ( len: 3; sym: -40 ),
{ 100: } ( len: 1; sym: -41 ),
{ 101: } ( len: 3; sym: -41 ),
{ 102: } ( len: 3; sym: -41 ),
{ 103: } ( len: 1; sym: -42 ),
{ 104: } ( len: 3; sym: -42 ),
{ 105: } ( len: 3; sym: -42 ),
{ 106: } ( len: 3; sym: -42 ),
{ 107: } ( len: 2; sym: -43 ),
{ 108: } ( len: 2; sym: -43 ),
{ 109: } ( len: 2; sym: -43 ),
{ 110: } ( len: 1; sym: -43 ),
{ 111: } ( len: 1; sym: -44 ),
{ 112: } ( len: 1; sym: -44 ),
{ 113: } ( len: 3; sym: -44 ),
{ 114: } ( len: 1; sym: -46 ),
{ 115: } ( len: 1; sym: -46 ),
{ 116: } ( len: 1; sym: -46 ),
{ 117: } ( len: 1; sym: -46 ),
{ 118: } ( len: 1; sym: -46 ),
{ 119: } ( len: 1; sym: -46 ),
{ 120: } ( len: 1; sym: -46 ),
{ 121: } ( len: 1; sym: -45 ),
{ 122: } ( len: 3; sym: -47 ),
{ 123: } ( len: 1; sym: -47 ),
{ 124: } ( len: 1; sym: -47 ),
{ 125: } ( len: 1; sym: -47 ),
{ 126: } ( len: 2; sym: -47 ),
{ 127: } ( len: 1; sym: -49 ),
{ 128: } ( len: 1; sym: -49 ),
{ 129: } ( len: 1; sym: -48 ),
{ 130: } ( len: 1; sym: -48 ),
{ 131: } ( len: 1; sym: -48 ),
{ 132: } ( len: 1; sym: -51 ),
{ 133: } ( len: 1; sym: -51 ),
{ 134: } ( len: 1; sym: -51 ),
{ 135: } ( len: 1; sym: -51 ),
{ 136: } ( len: 1; sym: -51 ),
{ 137: } ( len: 1; sym: -51 ),
{ 138: } ( len: 1; sym: -51 ),
{ 139: } ( len: 1; sym: -51 ),
{ 140: } ( len: 1; sym: -51 ),
{ 141: } ( len: 1; sym: -50 ),
{ 142: } ( len: 1; sym: -50 ),
{ 143: } ( len: 1; sym: -50 ),
{ 144: } ( len: 1; sym: -50 ),
{ 145: } ( len: 1; sym: -52 ),
{ 146: } ( len: 1; sym: -52 ),
{ 147: } ( len: 1; sym: -52 ),
{ 148: } ( len: 1; sym: -53 ),
{ 149: } ( len: 3; sym: -53 ),
{ 150: } ( len: 1; sym: -54 ),
{ 151: } ( len: 1; sym: -54 ),
{ 152: } ( len: 1; sym: -56 ),
{ 153: } ( len: 1; sym: -55 ),
{ 154: } ( len: 1; sym: -57 ),
{ 155: } ( len: 1; sym: -57 ),
{ 156: } ( len: 2; sym: -57 ),
{ 157: } ( len: 1; sym: -58 ),
{ 158: } ( len: 1; sym: -58 ),
{ 159: } ( len: 1; sym: -60 ),
{ 160: } ( len: 1; sym: -60 ),
{ 161: } ( len: 1; sym: -60 ),
{ 162: } ( len: 1; sym: -59 ),
{ 163: } ( len: 1; sym: -62 ),
{ 164: } ( len: 2; sym: -61 ),
{ 165: } ( len: 1; sym: -64 ),
{ 166: } ( len: 1; sym: -64 ),
{ 167: } ( len: 1; sym: -64 ),
{ 168: } ( len: 2; sym: -63 ),
{ 169: } ( len: 2; sym: -66 ),
{ 170: } ( len: 3; sym: -65 ),
{ 171: } ( len: 1; sym: -68 ),
{ 172: } ( len: 1; sym: -67 ),
{ 173: } ( len: 1; sym: -70 ),
{ 174: } ( len: 1; sym: -69 ),
{ 175: } ( len: 1; sym: -73 ),
{ 176: } ( len: 1; sym: -72 ),
{ 177: } ( len: 5; sym: -71 ),
{ 178: } ( len: 1; sym: -74 ),
{ 179: } ( len: 2; sym: -74 ),
{ 180: } ( len: 3; sym: -75 ),
{ 181: } ( len: 1; sym: -75 ),
{ 182: } ( len: 1; sym: -75 ),
{ 183: } ( len: 9; sym: -77 ),
{ 184: } ( len: 1; sym: -76 ),
{ 185: } ( len: 1; sym: -76 ),
{ 186: } ( len: 1; sym: -76 ),
{ 187: } ( len: 1; sym: -76 ),
{ 188: } ( len: 1; sym: -76 ),
{ 189: } ( len: 1; sym: -78 ),
{ 190: } ( len: 2; sym: -78 ),
{ 191: } ( len: 2; sym: -79 ),
{ 192: } ( len: 3; sym: -79 ),
{ 193: } ( len: 4; sym: -79 ),
{ 194: } ( len: 3; sym: -81 ),
{ 195: } ( len: 2; sym: -81 ),
{ 196: } ( len: 2; sym: -80 ),
{ 197: } ( len: 5; sym: -83 ),
{ 198: } ( len: 1; sym: -82 ),
{ 199: } ( len: 3; sym: -82 ),
{ 200: } ( len: 1; sym: -84 ),
{ 201: } ( len: 6; sym: -85 ),
{ 202: } ( len: 4; sym: -85 ),
{ 203: } ( len: 4; sym: -86 ),
{ 204: } ( len: 1; sym: -86 ),
{ 205: } ( len: 4; sym: -88 ),
{ 206: } ( len: 1; sym: -88 ),
{ 207: } ( len: 2; sym: -87 ),
{ 208: } ( len: 1; sym: -89 ),
{ 209: } ( len: 2; sym: -89 ),
{ 210: } ( len: 3; sym: -90 ),
{ 211: } ( len: 3; sym: -92 ),
{ 212: } ( len: 4; sym: -92 ),
{ 213: } ( len: 1; sym: -91 ),
{ 214: } ( len: 3; sym: -91 ),
{ 215: } ( len: 5; sym: -93 ),
{ 216: } ( len: 0; sym: -94 ),
{ 217: } ( len: 2; sym: -94 ),
{ 218: } ( len: 6; sym: -96 ),
{ 219: } ( len: 0; sym: -95 ),
{ 220: } ( len: 1; sym: -95 ),
{ 221: } ( len: 1; sym: -98 ),
{ 222: } ( len: 1; sym: -98 ),
{ 223: } ( len: 3; sym: -97 ),
{ 224: } ( len: 2; sym: -97 ),
{ 225: } ( len: 1; sym: -99 ),
{ 226: } ( len: 3; sym: -99 ),
{ 227: } ( len: 3; sym: -100 ),
{ 228: } ( len: 1; sym: -102 ),
{ 229: } ( len: 1; sym: -102 ),
{ 230: } ( len: 1; sym: -102 ),
{ 231: } ( len: 0; sym: -101 ),
{ 232: } ( len: 4; sym: -101 ),
{ 233: } ( len: 0; sym: -104 ),
{ 234: } ( len: 4; sym: -104 ),
{ 235: } ( len: 1; sym: -103 ),
{ 236: } ( len: 3; sym: -103 ),
{ 237: } ( len: 1; sym: -109 ),
{ 238: } ( len: 2; sym: -109 ),
{ 239: } ( len: 1; sym: -105 ),
{ 240: } ( len: 1; sym: -105 ),
{ 241: } ( len: 1; sym: -105 ),
{ 242: } ( len: 1; sym: -105 ),
{ 243: } ( len: 6; sym: -107 ),
{ 244: } ( len: 1; sym: -106 ),
{ 245: } ( len: 1; sym: -108 )
);


const _error = 256; (* error token *)

function yyact(state, sym : Integer; var act : Integer) : Boolean;
  (* search action table *)
  var k : Integer;
  begin
    k := yyal[state];
    while (k<=yyah[state]) and (yya[k].sym<>sym) do inc(k);
    if k>yyah[state] then
      yyact := false
    else
      begin
        act := yya[k].act;
        yyact := true;
      end;
  end(*yyact*);

function yygoto(state, sym : Integer; var nstate : Integer) : Boolean;
  (* search goto table *)
  var k : Integer;
  begin
    k := yygl[state];
    while (k<=yygh[state]) and (yyg[k].sym<>sym) do inc(k);
    if k>yygh[state] then
      yygoto := false
    else
      begin
        nstate := yyg[k].act;
        yygoto := true;
      end;
  end(*yygoto*);

label parse, next, error, errlab, shift, reduce, accept, abort;

begin(*yyparse*)

  (* initialize: *)

  yystate := 0; yychar := -1; yynerrs := 0; yyerrflag := 0; yysp := 0;

{$ifdef yydebug}
  yydebug := true;
{$else}
  yydebug := false;
{$endif}

parse:

  (* push state and value: *)

  inc(yysp);
  if yysp>yymaxdepth then
    begin
      yyerror('yyparse stack overflow');
      goto abort;
    end;
  yys[yysp] := yystate; yyv[yysp] := yyval;

next:

  if (yyd[yystate]=0) and (yychar=-1) then
    (* get next symbol *)
    begin
      yychar := yylex; if yychar<0 then yychar := 0;
    end;

  if yydebug then writeln('state ', yystate, ', char ', yychar);

  (* determine parse action: *)

  yyn := yyd[yystate];
  if yyn<>0 then goto reduce; (* simple state *)

  (* no default action; search parse table *)

  if not yyact(yystate, yychar, yyn) then goto error
  else if yyn>0 then                      goto shift
  else if yyn<0 then                      goto reduce
  else                                    goto accept;

error:

  (* error; start error recovery: *)

  if yyerrflag=0 then yyerror('syntax error');

errlab:

  if yyerrflag=0 then inc(yynerrs);     (* new error *)

  if yyerrflag<=2 then                  (* incomplete recovery; try again *)
    begin
      yyerrflag := 3;
      (* uncover a state with shift action on error token *)
      while (yysp>0) and not ( yyact(yys[yysp], _error, yyn) and
                               (yyn>0) ) do
        begin
          if yydebug then
            if yysp>1 then
              writeln('error recovery pops state ', yys[yysp], ', uncovers ',
                      yys[yysp-1])
            else
              writeln('error recovery fails ... abort');
          dec(yysp);
        end;
      if yysp=0 then goto abort; (* parser has fallen from stack; abort *)
      yystate := yyn;            (* simulate shift on error *)
      goto parse;
    end
  else                                  (* no shift yet; discard symbol *)
    begin
      if yydebug then writeln('error recovery discards char ', yychar);
      if yychar=0 then goto abort; (* end of input; abort *)
      yychar := -1; goto next;     (* clear lookahead char and try again *)
    end;

shift:

  (* go to new state, clear lookahead character: *)

  yystate := yyn; yychar := -1; yyval := yylval;
  if yyerrflag>0 then dec(yyerrflag);

  goto parse;

reduce:

  (* execute action, pop rule from stack, and go to next state: *)

  if yydebug then writeln('reduce ', -yyn);

  yyflag := yyfnone; yyaction(-yyn);
  dec(yysp, yyr[-yyn].len);
  if yygoto(yys[yysp], yyr[-yyn].sym, yyn) then yystate := yyn;

  (* handle action calls to yyaccept, yyabort and yyerror: *)

  case yyflag of
    yyfaccept : goto accept;
    yyfabort  : goto abort;
    yyferror  : goto errlab;
  end;

  goto parse;

accept:

  yyparse := 0; exit;

abort:

  yyparse := 1; exit;

end(*yyparse*);


{$I idllex.pas}

end.